#! /usr/bin/perl

# ================================================================== #
#  Fumy News Clipper Ver 2.13.0 - Hitokoto Bookmark Blog - [hb.cgi]  #
# ================================================================== #
#  Copyright (C) Fumihiro Nishimura.(Nishishi) 2006-2017.            #
#                                                                    #
#  Rg@\tj[XNbvCGIłBRgtubN}[N #
#  AY^EELEȈՃuOc[ȂǂƂĊpł܂B#
#                                                                    #
#  CGÍAlE@l킸AǂȂłRɂgp܂B   #
#  pp\łACGÎ̂L̔Ă͂܂B #
#                                                                    #
#  CGI̒쌠́AG(ɂ)ɂ܂B                   #
#  gpړIł̃JX^}CY(\[X)͎RɎ{č\܂  #
#  Aς̂s葽ɍĔzz邱Ƃ͋ւ܂B          #
#  ȂAȂ钘쌠\폜EρEǋLĂ͂Ȃ܂B      #
#                                                                    #
#  https://www.nishishi.com/                                         #
# ================================================================== #

use lib '.';
#use warnings;
use strict;
use CGI;
require 'fumyxml.pl';

# =============== #
#  [Uݒ聥 #
# =============== #

# f[^t@C
my $bmsdata = 'hb.xml';
# ݒt@C
my $setfile = 'hbsettings.txt';
# R[h
my $charcode = 'Shift_JIS';

# XLt@CiOj
my $skinfilecover = 'ncskin.html';
# XLt@CiNbvj
my $skinfileclip = 'ncclip.html';
# XLt@CiTCg}bvj
my $skinfilemap = 'ncsmap.html';

# pX[hEZbVIDۑt@C (Oǂ܂Ȃ悤Ɋgq.cgiɂĂ܂B)
my $passfile = 'upf.cgi';

# uEUIĂOCԂێ 1:YES(L܂ł̓OC܂) / 0:NO(uEUIƎOAEg)
my $keepsession = 1;

# Rgt[Xy[XɋLqꂽscript^O𖳌ɂ(1:ɂ/0:ɂȂ)
my $allowblacktags = 1;

# OCʉɕ\郁bZ[Wiȗ^HTML^Ogpj
my $MsgForLoginScreen = '';

# ======================================================================== #
# yJX^}CYցz                                               #
# CGI\[XCăJX^}CYł鍀ڂ͏LłB                #
# ȊO̐ݒ́AǗʂ́uݒFSettingsvj[ݒł܂B #
# ======================================================================== #

# -------------------------------------------- #
# ȍ~̓Ciݒ荀ڂ͂܂j #
# -------------------------------------------- #
my $versionnum = '2.13.0';

my %flagDebug = (
	NoAuthentication	=> 0,	# fobOpF؏ȗ	1:ON / 0:OFF
	ShowDebugStrings	=> 0	# fobOp̕\	1:ON / 0:OFF
);
my %flagDemo = (
	RefuseToChangePassword	=> 0,	# pX[h̕ύXہipX[hɐݒ肵ĂȂƍŏ̃pX[hȂȂ̂ŒӁBj 1:ON / 0:OFF
	RefuseToChangeSettings	=> 0,	# ݒ̕ύXہiKvȐݒɂĂƁBj 1:ON / 0:OFF
	LoginMessage	=> 0,			# fsp̃OCbZ[W 1:ON / 0:OFF
	NotAllowHtml	=> 0,			# HTML^O̎gpہiҏWUI𖳌sɂہj 1:ON / 0:OFF
	AddRelNofollow	=> 0			# Nbv̊ONׂĂɁurel="nofollow"vt 1:ON / 0:OFF
);

my $cryptkey = 'fx';	# pX[hÍL[(2)

my $cgi = new CGI;

my $showpage = $cgi->param('page') || 1;
my $showmode = $cgi->param('mode') || 'view';	# view / sitemap / edit / write / admin / getbackupfile / passcheck ( / rss )
my $showorder= $cgi->param('order') || 'straight';	# straight / reverse
my $clipnum  = $cgi->param('clip') || 0;
my $catnum   = $cgi->param('category');	# `ǂʂ̂ŏȂ
my $searchq  = $cgi->param('q') || '';
my $datelim  = $cgi->param('date') || '';
my $hashtag  = $cgi->param('tag') || '';
my $skindir  = $cgi->param('skin') || '';

# ef[^ێpϐQiȉ̊eڂ͊Ǘʂ́uݒvy[Wݒ\^ŒlύXĂf[^t@CɋL^ꂽݒ̕D悳܂Bj
my @categories;			# JeSXgǗpz
my %setdat = (
	categories => '',						# JeS (ǂݏ̕ێp ǂ񂾂炷 @categories ֓WJ)
	entryperpage => 15,						# 1y[W̃Gg
	entrypersitemappage => 1000,			# TCg}bv1y[W̃Gg
	plinknext => 'Next',					# y[WړNFúv
	plinkprev => 'Prev',					# y[WړNFuÓv
	plinkunit => 'Clips',					# y[WړNFuNbvv
	plinkarrownext => '&raquo;',			# y[WړNFEu>>v()
	plinkarrowprev => '&laquo;',			# y[WړNFu<<v(߂)
	pagenumbracket1 => '',					# y[WԍN̍
	pagenumbracket2 => '',					# y[WԍN̉E
	plinkbacktohome => 'S̕\ɖ߂',	# y[WړNFuŏɖ߂v
	plinkseparator => '<br>',				# y[WړNFZp[^						(Wł͉s)
	fixedclipnum => 0,						# 擪ɌŒ\Nbv̔ԍ					(0ȂŒȂ)
	readmoreonoff1 => 1,					# ǂދ@\Normal IndexŗLɂ邩		(1:L/0:)
	readmoreonoff2 => 1,					# ǂދ@\JeS莞ɗLɂ邩		(1:L/0:)
	readmoreonoff3 => 0,					# ǂދ@\TCgɗLɂ邩		(1:L/0:)
	readmoreonoff4 => 1,					# ǂދ@\t莞ɗLɂ邩			(1:L/0:)
	readmoreonoff5 => 0,					# ǂދ@\nbV^Ow莞ɗLɂ邩	(1:L/0:)
	readmoreonoff6 => 1,					# ǂދ@\ʕ\ɗLɂ邩			(1:L/0:)
	readmorehtmltag => 0,					# ǂދ@\ŉB𕢂߂HTML^O		(0:span/1:div/2:p)
	readmorelinklabel => 'ǂ',		# ǂރNɕtftHg		(1ȏKv)
	readmorecloseuse => 0,					# ǂ񂾌̏ރN\邩ǂ		(1:\/0:\Ȃ)
	readmorecloselabel => '',			# ǂ񂾌̏ރNɕtftHg	(1ȏKv)
	textareasizenormal => 9,				# NbveҏẄ̒(s)FǗʏ̏ꍇ
	textareasizequick => 7,					# NbveҏẄ̒(s)FNCbNȅꍇ
	hideclipurlinput => '',					# CLIP URL ͗\ɂ						(checked:\/󕶎:\)
	clipremoval => 0,						# ҏWNbv擪Ɉړ邩ǂ̃ftHgl	(1:YES / 0:NO)
	allowtag => '',							# ^O`FbN{bNX̃ftHgl			(checked or 󕶎)
	allowand => '',							# ̎QƋ`FbN{bNX̃ftHgl		(checked or 󕶎)
	freespace => '',						# t[Xy[XpHTML                                     
	hashtagcount => '',						# nbV^OꗗƏWv(ێp)	(zWJO̕)
	hashtagsort => 1,						# nbV^Oꗗ̌fڏ			(0:o / 1:ȏ(ʂȂo) / 2:ȍȂ(ʂȂo) / 3:ȏ(ʂȂ當R[h) / 4:ȍȂ(ʂȂ當R[h)
	dateselecthtml => '',					# tv_Ej[HTML\[X (ێp)
	datelisthtml => '',						# tNXgHTML\[X (ێp)
	categorycountdat => '',					# JeS̃JEgf[^ (ێp)
	sessiontimenum => 1.5,					# ZbV̗L( or )@WݒF1.5ԁi0.5ԁ`366j
	sessiontimeunit => 0,					# ZbV̗L̒P		0: 1:

	urlautolink => 1,						# Rg{URLŃNɂH(1:/0:Ȃ)
	postformItemNo			=> 1,			# EditNo\邩(1:/0:Ȃ)@ݒlɂ炸AQUICKeł͏ɔ\(XVKeȂ̂)
	postformItemTitle		=> 1,			# ^Cg\邩(1:/0:Ȃ)
	postformItemClipUrl		=> 1,			# CLIP URL\邩(1:/0:Ȃ)
	postformItemCategory	=> 1,			# JeS\邩(1:/0:Ȃ)
	postformItemComment		=> 1,			# Rg\邩(1:/0:Ȃ)
	postformItemDate		=> 1,			# e\邩(1:/0:Ȃ)
	postformItemOptions		=> 1,			# eIvVQ\邩(1:/0:Ȃ)@\̏ꍇ́ASIvVOFFɐݒ肵̂ƓʂɂȂB
	postformTimeoutGuide	=> 0,			# ^CAEgē\邩(1:/0:Ȃ)@ݒlɂ炸AǗʓeł͏ɕ\
	showreverseheader => 't',			# tł̕\̃^Cg擪ɕt镶
	sitemappreheader => 'TCg}bv',		# TCg}bv\̃^Cg擪ɕt镶

	# ȉ(2.12.0_Őݒ̓tH[Ȃ)
	datelistShowYear => 1					# etXgFNPƂ̊Kw邩ǂ (1:/0:Ȃ)
);

# ƗpϐQ
my @hashtaglist;		# nbV^Oi[p2z (ĂƂ͌Ȃ)
my @apnlnums = (60,97,32,104,114,101,102,61,34,104,116,116,112,115,58,47,47,119,119,119,46,110,105,115,104,105,115,104,105,46,99,111,109,47,99,103,105,47,110,101,119,115,99,108,105,112,47,34,62,70,117,109,121,32,78,101,119,115,32,67,108,105,112,112,101,114,60,47,97,62);
my @auli = (60,97,32,104,114,101,102,61,34,104,116,116,112,115,58,47,47,119,119,119,46,110,105,115,104,105,115,104,105,46,99,111,109,47,34,62);

# ݒt@Cǂ
&loadsettings();

# ZbVL(b)ݒ
my $sessiontimeout = &calcsessionlimit( $setdat{'sessiontimenum'}, $setdat{'sessiontimeunit'} );

# f[^t@Cǂ
my @xmldata = &fumyxmlpackage::XMLin($bmsdata,'clip');

# XLꎞKp̔f
my $inputtagforapplyskin = '';	# XLIԂێ̂ɕKvinputvf
my $queryforapplyskin = '';		# XLIԂێ̂ɕKvȃNG(&Lt)
if( $skindir ne '' ) {
	&overrideskins( $skindir );
	$inputtagforapplyskin = '<input type="hidden" name="skin" value="' . &forsafety($skindir) . '">';
	$queryforapplyskin = '&amp;skin=' . &forsafety($skindir);
}

# sp[^̊mF(x̌㋭I)
$showpage = &paramneednum( $showpage );
$clipnum  = &paramneednum( $clipnum  );

# JeS̒lmFĒ
if( !defined($catnum) ) { 
	# `Ȃ-1
	$catnum = -1;
}
else {
	# `ȊOȂ琳̐̂݋e
	$catnum = &paramneednum( $catnum );
}

# p[^ُ̈C
if( $showpage <= 0 ) { $showpage = 1; }		# y[Wԍ1
elsif( $showpage > $#xmldata+1 ) { $showpage = $#xmldata+1; }	# y[Wԍ̏̓f[^ (Ô)
if( $clipnum < 0 )   { $clipnum = 0; }		# Nbvԍ0
if( $setdat{'entryperpage'} < 1 ) { $setdat{'entryperpage'} = 15; }
if( $setdat{'entrypersitemappage'} < 1 ) { $setdat{'entrypersitemappage'} = 1000; }

# [hʏ
if( $showmode eq 'view' || $showmode eq 'sitemap' ) {

	# ===========================
	# VIEW MODE
	# ===========================
	my $coverfirst;  # COVERO
	my $coversecond; # COVER㔼
	my @cliphtmls;	 # Nbvf[^(WJ)

	# t
	if( $showorder eq 'reverse' ) {
		# tȂf[^̔zt]
		@xmldata = reverse(@xmldata);
	}

	# wNbv̐擪Œ菈iw肳Ă΁j
	if( $setdat{'fixedclipnum'} > 0 ) {
		&put1cliptohead( $setdat{'fixedclipnum'} );
	}

	# XLt@C̑݊mF
	if(!( -f $skinfilecover )) { &errormsg('XLt@C(O)ǂݍ߂܂łB݂t@CmFĉB','');}
	if(!( -f $skinfileclip )) {  &errormsg('XLt@C(Nbv)ǂݍ߂܂łB݂t@CmFĉB',''); }

	print $cgi->header( -type => "text/html" , -charset => $charcode );

	# y[WړN쐬
	my $nextpagenum = $showpage + 1;
	my $prevpagenum = $showpage - 1;

	# SKINt@C̓ǂݍ(COVER)
	open SKIN, $skinfilecover;
	my $temp = join("",<SKIN>);
	close SKIN;

	# SKINt@C̓ǂݍ(CLIP or SITEMAP)
	my $clipskin;
	if( $showmode eq 'sitemap' ) {
		# TCg}bv\[hATCg}bvXLǂ
		if( open(SMAP, $skinfilemap) ) {
			# Jǂ
			$clipskin = join("",<SMAP>);
			close SMAP;
		}
		else {
			# JȂftHgf[^
			$clipskin = qq|<!-- TCg}bvpXLt@C݂Ȃ̂ŃftHgf[^gpF --><p class="sitemap-item"><a href="[[PARMALINK]]" class="sitemap-parmalink"><span class="sitemap-id">[[ID]]:</span>[[TITLE]]</a> <span class="sitemap-cat"><a href="[[CATEGORYURL:SITEMAP]]">[[CATEGORY]]</a></span> <span class="sitemap-date">[[DATELINK:SITEMAP]]</span></p>\n|;
		}
	}
	else {
		# ʏ(view)[hANbvXLǂ
		open CLIP, $skinfileclip;
		$clipskin = join("",<CLIP>);
		close CLIP;
	}

	# 쑬x̂߂̃tOQiCOVER SKINɓ̃L[[h邩ǂOɊmFĂj
	my $isExistCategories = 0;
	my $isExistDatebox = 0;
	my $isExistHashtaglist = 0;
	my $isExistQuickpost = 0;
	my $isExistFreespaceNum = 0;
	my $isExistTopClips = 0;
	my $isUseReadmoreFunc = $setdat{'readmoreonoff1'} + $setdat{'readmoreonoff2'} + $setdat{'readmoreonoff3'} + $setdat{'readmoreonoff4'} + $setdat{'readmoreonoff5'} + $setdat{'readmoreonoff6'};	# l0Ȃuǂށv͊Sɕsv
	if( $temp =~ m/\[\[CATEGORIES\]\]/ ) 	{	$isExistCategories = 1;		}	# JeSꗗ̌fڂꍇ
	if( $temp =~ m/\[\[DATEBOX/ ) 			{	$isExistDatebox = 1;		}	# tw葋̌fڂꍇiIvV܂߂ă`FbN̂ŕʂ܂߂Ȃj
	if( $temp =~ m/\[\[HASHTAGLIST\]\]/ )	{	$isExistHashtaglist = 1;	}	# nbV^OXǧfڂꍇ
	if( $temp =~ m/\[\[QUICKPOST\]\]/ ) 	{	$isExistQuickpost = 1;		}	# NCbNetH[̌fڂꍇ
	if( $temp =~ m/\[\[FREESPACE:\d+/ )		{	$isExistFreespaceNum = 1;	}	# ԍtt[Xy[X̌fڂꍇiIvV܂߂ă`FbN̂ŕʂ܂߂Ȃj
	if( $temp =~ m/\[\[TOPCLIPSLINK/ ) 		{	$isExistTopClips = 1;		}	# XVē̌fڂꍇ

	# y[W݃tO
	my $existprevpage = 0;	# Õy[W݂邩ǂ(0:Ȃ,1:)
	my $existnextpage = 0;	# ̃y[W݂邩ǂ(0:Ȃ,1:)

	# ĕ\pHTML쐬
	my $counter=0;
	foreach my $oneclip (@xmldata) {

		my $cliptemplate = $clipskin;	# NbvXLRs[

		# 
		my $id		= &forsafety( &fumyxmlpackage::getcontent($oneclip,'id') );
		my $datetime= &forsafety( &fumyxmlpackage::getcontent($oneclip,'date') );
		my $title	= &forsafety( &fumyxmlpackage::getcontent($oneclip,'title') );
		my $newsurl	= &forsafety( &fumyxmlpackage::getcontent($oneclip,'newsurl') );
		my $category= &forsafety( &fumyxmlpackage::getcontent($oneclip,'category') );
		my $comment	= &checkblacklist( &fumyxmlpackage::getcontent($oneclip,'comment') );

		# \Ώۂ̔
		if( $clipnum > 0 && $id != $clipnum ) {
			# ʃNbv\̏ꍇIDႤȂ玟T
			next;
		}
		if( $catnum > -1 && $category != $catnum ) {
			# JeSw̏ꍇŃJeSԍႤȂ玟T
			next;
		}
		if( $hashtag ne '' ) {
			# ^Ȍꍇ
			my $temphs = $comment;
			$temphs =~ s/#\[+/#[/g;	# pʂAĂ(Ԃ񐳋K\)G[ɂȂ錻ۂ邽ߘApʂ1ɂ܂Ƃ߂ĂB
			# ^O܂܂Ă邩ǂmFiě₷̂߂ɏ璷ɋLqĂj
			my $quoted_hashtag = quotemeta($hashtag);
			if(     $temphs =~ m/#\[$quoted_hashtag\]/i ) {	}	# (Through)\FpʂɈ͂܂ꂽnbV^O
			elsif ( $temphs =~ m/#$quoted_hashtag[\W]/i ) {	}	# (Through)\FɉpȊO̕񂪑݂銇ʂȂnbV^O
			elsif ( $temphs =~ m/#$quoted_hashtag$/i ) {	}	# (Through)\Fɑ݂銇ʂȂnbV^O
			else {
				# Ȃ玟T
				next;
			}
		}
		if( $searchq ne '' ) {
			# ̏ꍇi^CgEURLERg{Ώہj
			my $searchstring = $title . ' ' . $newsurl .  ' ' . $comment;
			my $quoted_searchq = quotemeta($searchq);
			if( $searchstring !~ m/$quoted_searchq/ ) {
				# Ȃ玟T
				next;
			}
		}
		if( $datelim ne '' ) {
			# tw̏ꍇ
			my $quoted_datelim = quotemeta($datelim);
			if( $datetime !~ m/$datelim/ ) {
				# ĂΎT
				next;
			}
		}

		# JE^i݂w\ΏہxGg̉ԖڂȂ̂ێjSGgɑ΂ԍƂ͌Ȃ
		$counter++;

		# y[WǗ
		if( $showmode eq 'sitemap' ) {
			# TCg}bv[hȂ1y[W̕\C
			$setdat{'entryperpage'} = $setdat{'entrypersitemappage'};
		}
		my $startid = ($setdat{'entryperpage'} * ($showpage - 1)) + 1;	# Ԗڂ\Jn΂vZ
		my $endid   = ($startid + $setdat{'entryperpage'}) - 1;			# Ԗڂ܂ŕ\΂vZ
		if( $counter < $startid ) {
			# 摗
			$existprevpage = 1;		# Õy[W݂tO
			next;
		}
		if( $counter > $endid ) {
			# Nbv\ׂ
			# ̃y[W݂tO𗧂Ăă[vI
			$existnextpage = 1;
			#last;
			next;	# sdlύXt[v͒fɍŌ܂ő
		}

		# ȉ͌ʃNbv̓e\邽߂̏

		# ǗpN쐬
		my $parmalink = '?' . "clip" . '=' . $id;
		my $editlink  = '?' . "mode" . '=' . "edit" . '&amp;' . "clip" . '=' . $id;

		# JeSN쐬
		my $categorylink = '?';
		if( $category >= 0 ) {
			$categorylink .= "category" . '=' . $category;
		}
		my $categorymaplink = $categorylink . '&amp;mode=sitemap';

		# ڕ\pCLIP URL
		my $newsurldisp = $newsurl;
		# CLIP URLȂꍇ
		if( $newsurl eq 'NO URL' ) {
			$newsurl = '?';		# Np
			$newsurldisp = '';	# \p
		}

		# tN쐬
		my $datemaplink = $datetime;
		if( $datetime =~ m|(\d\d\d\d)/(\d\d)/(.*)| ) {
			$datemaplink = qq|<a href="?mode=sitemap&amp;date=$1">$1</a>/<a href="?mode=sitemap&amp;date=$1/$2">$2</a>/$3|;
		}

		# RgɊ܂܂nbV^O֘A (Ɨ̊֐ɂӖ͂Ȃ)
		$comment = &extracthashtagsandlink( $comment );

		# RgɊ܂܂URLN (K\1sŏI I)
		if( $setdat{'urlautolink'} != 0 ) {
			$comment =~ s|((?<!=")https?:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:@&=+$,%#]+)|<a href="$1">$1</a>|g;	# ے߂ǂ (?<!regex)gpB
		}

		# uǂށviuǂށv@\1ʂłłLɐݒ肳Ăꍇɂsj
		if( $isUseReadmoreFunc > 0 ) {
			my $alreadysepcheck = $comment =~ s/&lt;&gt;/<>/g;	# ̎QƂŋL^Ăꍇ͌ɖ߂BiɌ𓾂Ăj
			# RgɁuǂށv؂蕶܂܂ꍇ̏
			if( $alreadysepcheck > 0 || $comment =~ m/<>/ ) {	# ̎QƂꍇɑ2xsȂ悤AɃ`FbN
				# ǂޏ{ʂǂ𔻕
#				if( $clipnum > 0 ) {
#					# ʃNbv\ł΁Auǂށv͕svB
#					$comment =~ s/<>//g;
#				}
				if(
					( $setdat{'readmoreonoff6'} == 1 && $clipnum > 0 )		# ʃNbv\̏ꍇŁAǂދ@\Nbv\ɗLȏꍇ
					||
					( $setdat{'readmoreonoff2'} == 1 && $catnum > -1 && $searchq eq '' && $clipnum == 0 )		# JeS\̏ꍇŁAǂދ@\JeS莞ɗLȏꍇiAł͂Ȃꍇj
					||
					( $setdat{'readmoreonoff5'} == 1 && $hashtag ne '' && $clipnum == 0 )	# nbV^OI\̏ꍇŁAǂދ@\nbV^Ow莞ɗLȏꍇ
					||
					( $setdat{'readmoreonoff3'} == 1 && $searchq ne '' && $clipnum == 0 )		# S̏ꍇŁAǂދ@\ɗLȏꍇ
					||
					( $setdat{'readmoreonoff4'} == 1 && $datelim ne '' && $clipnum == 0 )		# tw̏ꍇŁAǂދ@\t莞ɗLȏꍇ
					||
					( $setdat{'readmoreonoff1'} == 1 && $catnum == -1 && $hashtag eq '' && $searchq eq '' && $datelim eq '' && $clipnum == 0 )		# m[}Ԃőǂދ@\Lȏꍇ
				) {
					# ǂރN邽߂̏
					my $readmorehidetag = 'span';
					if( $setdat{'readmorehtmltag'} == 1 ) { $readmorehidetag = 'div'; }
					elsif( $setdat{'readmorehtmltag'} == 2 ) { $readmorehidetag = 'p'; }

					# ǂރN鏈
					my @separatedcomments = split(/<>/,$comment);
					$comment = '';
					my $spcomcount = 0;
					foreach my $sepcomment (@separatedcomments) {
						if( $comment eq '' ) {
							# ŏ͖\
							$comment = $sepcomment;
						}
						elsif( $sepcomment eq '' ) {
							# gȂΖ
							next;
						}
						else {
							# 2Ԗڈȍ~́uǂށvdlig΁j
							my $moreid = 'clip' . $id . 'more' . $spcomcount;						# ǂޗ̈11Ɋ蓖Ă郆j[NID
							my $morenum = ''; if( $spcomcount >= 2 ) { $morenum = $spcomcount; }	# ǂނ2ȏ゠ꍇɌĔԍt邽
							$comment .= qq|<!-- \n	ǂ$spcomcount(B) --><a href="$parmalink" id="button4$moreid" style="display:none;" class="readmorebutton" onclick="document.getElementById('$moreid').style.display = 'inline'; this.style.display = 'none'; return false;">$setdat{'readmorelinklabel'}$morenum</a>|;
							$comment .= qq|<!-- \n	ǂ$spcomcount(H) --><$readmorehidetag id="$moreid" class="readmorearea">| . $sepcomment;
								if( $setdat{'readmorecloseuse'} != 0 ) { $comment .= qq|<a href="$parmalink" id="button4$moreid" class="readmorebutton" onclick="document.getElementById('$moreid').style.display = 'none'; document.getElementById('button4$moreid').style.display = 'inline'; return false;">$setdat{'readmorecloselabel'}$morenum</a>|; }
							$comment .= qq|</$readmorehidetag>|;
							$comment .= qq|<!-- \n	ǂ$spcomcount(S) --><script type="text/javascript">document.getElementById('$moreid').style.display = 'none'; document.getElementById('button4$moreid').style.display = 'inline-block';</script>|;
						}
						$spcomcount++;
					}
				}
				else {
					# OȂuǂށv͕sv
					$comment =~ s/<>//g;
				}
			}
		}

		# 擪Œ̏ꍇɌŒp
		my $fixedsign = '';
		if( $setdat{'fixedclipnum'} == $id ) { $fixedsign = '<span class="fixedsign">(擪Œ)</span>'; }

		# NbvXLHTML쐬1(P})
		$cliptemplate =~ s/\[\[ID\]\]/$id$fixedsign/g;
		$cliptemplate =~ s/\[\[TITLE\]\]/$title/g;
		$cliptemplate =~ s/\[\[CATEGORY\]\]/$categories[$category]/g;
		$cliptemplate =~ s/\[\[CATEGORYURL\]\]/$categorylink/g;
		$cliptemplate =~ s/\[\[CATEGORYURL:SITEMAP\]\]/$categorymaplink/g;
		$cliptemplate =~ s/\[\[NEWSURL\]\]/$newsurl/g;
		$cliptemplate =~ s/\[\[NEWSURL:DISP\]\]/$newsurldisp/g;
		$cliptemplate =~ s/\[\[DATE\]\]/$datetime/g;
		$cliptemplate =~ s/\[\[DATELINK:SITEMAP\]\]/$datemaplink/g;
		$cliptemplate =~ s/\[\[COMMENT\]\]/$comment/g;
		$cliptemplate =~ s/\[\[COMMENTCOUNT\]\]/length($comment)/eg;
		$cliptemplate =~ s/\[\[PARMALINK\]\]/$parmalink/g;
		$cliptemplate =~ s/\[\[EDITLINK\]\]/$editlink/g;

		# NbvXLHTML쐬2()
		$cliptemplate =~ s/\[\[DATE:JP\]\]/&cutheadd(&datetojpstyle($datetime))/eg;

		# XL܂߂ĐHTMLɑ΂ď
		if( $flagDemo{'AddRelNofollow'} == 1 ) {
			# ON(http珑ꂽN)݂̂ɑlurel="nofollow"v
			$cliptemplate =~ s/<([aA]\s.*)([hH][rR][eE][fF]=.*http.*)>/<$1rel="nofollow" $2>/g;
		}

		push( @cliphtmls, $cliptemplate );

	}

	# F̎_ŁAϐ counter ɂ͕\ɍvNbv̑ĂB()

	# y[WړN
	# (IvV)
	my $linkoptions = '';
	if( $clipnum > 0 ) {
		# NbvNG[iID̓j[NȔԍȂ̂ŁAf[^œ삵ĂÃR[hs邱Ƃ͂ȂBID̃Nbv݂͑ȂBj
		$linkoptions .= "&amp;clip=" . &forsafety($clipnum);
	}
	if( $catnum > -1 ) {
		# JeSNG[
		$linkoptions .= "&amp;category=" . &forsafety($catnum);
	}
	if( $hashtag ne '' ) {
		# nbV^ONG[
		my $htagencoded = &forsafety($hashtag);
		$htagencoded =~ s/(\W)/'%'.unpack('H2',$1)/eg;
		$linkoptions .= "&amp;tag=$htagencoded";
	}
	if( $searchq ne '' ) {
		# NG[
		my $sqencoded = &forsafety($searchq);
		$sqencoded =~ s/(\W)/'%'.unpack('H2',$1)/eg;
		$linkoptions .= "&amp;q=$sqencoded";
	}
	if( $datelim ne '' ) {
		# twNG[
		$linkoptions .= "&amp;date=" . &forsafety($datelim);
	}

	# y[WړNɍPnݒt
	if( $showmode eq 'sitemap' ) {
		# TCg}bv̏ꍇF
		$linkoptions .= "&amp;mode=sitemap";
	}
	if( $showorder eq 'reverse' ) {
		# t̏ꍇF
		$linkoptions .= "&amp;order=reverse";
	}

	# y[WړpN
	my $nextpagelink = "";
	if ( $existnextpage > 0 ) {
		# ܂̃y[WΎփN
		$nextpagelink = qq|<a href="?page=$nextpagenum$linkoptions" class="nextlink">$setdat{'plinknext'} $setdat{'entryperpage'} $setdat{'plinkunit'} $setdat{'plinkarrownext'}</a>|;
	}
	my $prevpagelink = "";
	if( $existprevpage > 0 ) {
		# Õy[WΖ߂郊N
		$prevpagelink = qq|<a href="?page=$prevpagenum$linkoptions" class="prevlink">$setdat{'plinkarrowprev'} $setdat{'plinkprev'} $setdat{'entryperpage'} $setdat{'plinkunit'}</a>|;
		if( $nextpagelink ne "" ) {
			# փNȂ؂
			$prevpagelink .= ' <span class="linkseparator">/</span> ';
		}
	}

	# y[WXgNi counter: / bmsperpage:1y[W̕\ / showpage:̃y[W )
	my $pagelistlinks = "";
	my $totalpage = int($counter / $setdat{'entryperpage'});
	if($counter % $setdat{'entryperpage'} > 0) { $totalpage++; }	# y[W
	if( $totalpage >= 2 ) {
		# y[W2ȏ̏ꍇ̂ݐ
		my $pagenumcounter = 1;
		while( $pagenumcounter <= $totalpage ) {
			# y[WƂւ̃N쐬
			my $pagenumlinkclass = "pagenumlink";
			if( $pagenumcounter == $showpage ) { $pagenumlinkclass = "pagenumlink pagenumhere"; }
			$pagelistlinks .= qq|$setdat{'pagenumbracket1'}<a href="?page=$pagenumcounter$linkoptions" class="$pagenumlinkclass">$pagenumcounter</a>$setdat{'pagenumbracket2'} |;
			$pagenumcounter++;
		}
	}

	# \Ώۂ肳Ăۂ̌fڏ
	my $backdeflink = '';
	my $limitmsg = '';
	if( $clipnum > 0 || $catnum > -1 || $hashtag ne '' || $searchq ne '' || $datelim ne '' || $showmode eq 'sitemap' ) {
		# S̕\ɖ߂郊N
		if( $nextpagelink ne '' || $prevpagelink ne '' ) { $backdeflink = $setdat{'plinkseparator'}; }	# y[WړNΎwZp[^(Wł͉s)Ă
		$backdeflink .= qq|<a href="?">$setdat{'plinkbacktohome'}</a>\n|;
	}
	# ē̕\
	my $catname;
	if( $catnum > -1 ) {
		# JeSȂJeSf
		$catname = &forsafety($categories[$catnum]);
		if( $catname eq '' ) {
			$catname = '̖ݒ';
		}
		$limitmsg = 'JeSu' . $catname . 'v̈ꗗ';
	}
	if( $hashtag ne '' ) {
		# nbV^OȂ猟f
		$limitmsg = '^Ou' . &forsafety($hashtag) . 'v̕tꂽNbvꗗ';
	}
	if( $searchq ne '' ) {
		# Ȃ猟f
		$limitmsg = 'u' . &forsafety($searchq) . 'v̌';
	}
	if( $datelim ne '' ) {
		# twȂtf
		$limitmsg = &datetojpstyle( &forsafety($datelim) ) . '̃Nbvꗗ';
	}
	if( $catnum > -1 && $searchq ne '' ) {
		# JeSƌ̕
		$limitmsg = 'JeSu' . $catname . 'vɌ肵Au' . &forsafety($searchq) . 'v̌';
	}
	if( $catnum > -1 && $datelim ne '' ) {
		# JeSƓtw̕
		$limitmsg = 'JeSu' . $catname . 'vɌ肵' . &datetojpstyle( &forsafety($datelim) ) . '̃Nbvꗗ';
	}
	if( $showorder eq 'reverse' ) {
		$limitmsg .= &forsafety($setdat{'showreverseheader'});
	}
	# \ǉ
	if( $limitmsg ne '' ) {
		$limitmsg .= "m$countern";
	}
	# \Ƀy[Wԍǉ
	if( $limitmsg ne '' && $showpage > 1 ) {
		$limitmsg .= "i$showpagey[Wځj";
	}

	# TCg}bv̏ꍇF
	if( $showmode eq 'sitemap' ) {
		$limitmsg = &forsafety($setdat{'sitemappreheader'}) . 'F' . $limitmsg;
	}

	# y[WړN̑}iCOVERXLɑ΂āj
	$temp =~ s/\[\[PAGELISTLINKS\]\]/$pagelistlinks/g;
	$temp =~ s/\[\[PAGELINKS\]\]/$prevpagelink $nextpagelink $backdeflink/g;

	# JeSꗗ̑}iCOVERXLɑ΂āj
	if( $isExistCategories == 1 ) {
		# JeSꗗ̌fڂꍇ݂̂ɏF
		my @catcounts;
		if( $setdat{'categorycountdat'} eq '' ) {
			# JeSJEgf[^Ȃ琶s
			@catcounts = &categorycounter();
		}
		else {
			# JeS̃JEgf[^Ȃ炻ǂ
			@catcounts = split(/,/,$setdat{'categorycountdat'});
		}
		my @catlisthtmls;
		push(@catlisthtmls,'<ul class="categorylist">');
		my $catlistcount=0;
		foreach my $onecatitem (@categories) {
			if( $catlistcount > 0 ) {
				# JeSuȂvȊO\
				my $catlink = '?' . "category" . '=' . $catlistcount;
				push(@catlisthtmls,"<li class=\"cat$catlistcount\"><a href=\"$catlink\">$onecatitem</a><span class=\"num\">($catcounts[$catlistcount])</span></li>");
			}
			$catlistcount++;
		}
		push(@catlisthtmls,'</ul>');
		my $categorylist = join("\n",@catlisthtmls);
		$temp =~ s/\[\[CATEGORIES\]\]/$categorylist/g;
	}

	# \ē̑}
	$limitmsg = '<p class="limitmessage">' . $limitmsg . '</p>';
	$temp =~ s/\[\[LIMITMESSAGE\]\]/$limitmsg/g;

	# XVēN{bNX̑}
	if( $isExistTopClips == 1 ) {
		# XVēN{bNX̌fڂꍇ̂ݏF
		$temp =~ s/\[\[TOPCLIPSLINK:([A-Z]+):(\d+)\]\]/&gettopclips($1,$2)/eg;
	}

	# t[Xy[X̎}ŝAHTML^O؂蕶̎}͍폜ĂiӐ}IȘAs̉sɂȂ镛p邪j
	$setdat{'freespace'} =~ s/><br>/>/g;
	$setdat{'freespace'} = &checkblacklist( $setdat{'freespace'} );	# XNvg𖳌ɂ邩ǂ̊mFƏ

	# ԍtt[Xy[X̑}
	if( $isExistFreespaceNum == 1 ) {
		# ԍtt[Xy[X̌fڂꍇ̂ݏF
		my @eachfreespaces = split(/<>/,$setdat{'freespace'});
		$temp =~ s/\[\[FREESPACE:(\d+)\]\]/$eachfreespaces[$1]/g;

		# fڏwIvVt̃t[Xy[X
		if( $clipnum > 0 ) {
			# Nbv\Ȃ
			$temp =~ s/\[\[FREESPACE:(\d+)\/IF-ONECLIP\]\]/$eachfreespaces[$1]/g;
		}
		elsif ( $catnum > -1 ) {
			# JeS\Ȃ
			$temp =~ s/\[\[FREESPACE:(\d+)\/IF-CATEGORY\]\]/$eachfreespaces[$1]/g;			# SJeSΏ
			$temp =~ s/\[\[FREESPACE:(\d+)\/IF-CATEGORY:$catnum\]\]/$eachfreespaces[$1]/g;	# JeSԍ̂ݑΏ
		}
		elsif ( $clipnum == 0 && $catnum == -1 && $hashtag eq '' && $searchq eq '' && $datelim eq '' ) {
			# ̏ȂԂȂ
			$temp =~ s/\[\[FREESPACE:(\d+)\/IF-NORMALINDEX\]\]/$eachfreespaces[$1]/g;
			if( $showpage < 2 ) {
				# 1y[WڂȂ
				$temp =~ s/\[\[FREESPACE:(\d+)\/IF-HOME\]\]/$eachfreespaces[$1]/g;
			}
		}
		# Ȍꍇ̓Rg}
		$temp =~ s/\[\[FREESPACE:(\d+)\/IF-[\w:]+\]\]/<!-- NOT MATCH CONDITIONS [$1] -->/g;
	}

	# t[Xy[X̑}
	$setdat{'freespace'} =~ s/<>//g;		# ؂蕶폜ĂB
	$temp =~ s/\[\[FREESPACE\]\]/$setdat{'freespace'}/g;

	# t[Xy[XҏWpURL̑}
	$temp =~ s/\[\[FREESPACEEDIT\]\]/?mode=admin&amp;work=setting&amp;page=2/g;

	# ̑}
	my $searchboxhtml = qq|<form action="./hb.cgi" method="get" class="searchbox"><span class="searchinputs">$inputtagforapplyskin<input type="text" value="| . &forsafety($searchq) . qq|" name="q" class="queryinput"><input type="submit" value="" class="submitbutton"></span>|;
	if( $catnum > -1 ) {
		$searchboxhtml .= qq|<p class="searchtarget limitedsearch"><label><input type="checkbox" value="| . &forsafety($catnum) . qq|" name="category" checked>݂̃JeSɌ肵Č</label></p>|;
	}
	else {
		$searchboxhtml .= qq|<p class="searchtarget">ׂẴNbvΏۂɌ</p>|;
	}
	$searchboxhtml .= qq|</form>|;
	$temp =~ s/\[\[SEARCHBOX\]\]/$searchboxhtml/g;

	# tw葋̑}
	if( $isExistDatebox == 1 ) {
		# tw葋̌fڂꍇ݂̂ɏF
		if( $setdat{'dateselecthtml'} eq '' || $setdat{'datelisthtml'} eq '' ) {
			# tv_Ej[HTML\[XEtNXgHTML\[X̂ǂ炩Ȃ琶ɂ
			&datadatecounter();
		}

		$temp =~ s/\[\[DATEBOX\]\]/$setdat{'dateselecthtml'}\n$setdat{'datelisthtml'}/g;	# 
		$temp =~ s/\[\[DATEBOX:PULL\]\]/$setdat{'dateselecthtml'}/g;	# t葋
		$temp =~ s/\[\[DATEBOX:LIST\]\]/$setdat{'datelisthtml'}/g;	# tNXg
	}

	# o[W̑}
	my $poweredby = qq|Powered by <a href="https://www.nishishi.com/cgi/newsclip/">Fumy News Clipper</a> Ver $versionnum|;
	$temp =~ s/\[\[VERSION\]\]/$poweredby/g;

	# TCg}bvy[Wւ̃N}
	my $sitemaplink = qq|<a href="?mode=sitemap">$setdat{'sitemappreheader'}y[W</a>|;
	$temp =~ s/\[\[SITEMAPLINK\]\]/$sitemaplink/g;

	# TCg}bvURL̑}
	$temp =~ s/\[\[SITEMAPURL\]\]/?mode=sitemap/g;

	# TCg}bv̑}
	$temp =~ s/\[\[SITEMAPNAME\]\]/$setdat{'sitemappreheader'}/g;

	# ̕\tɂURL̑}
	my $revurl = &managequerystring('order','reverse');
	$temp =~ s/\[\[REVERSEURL\]\]/$revurl/g;

	# ̕\tɂ閼̂̑}
	$temp =~ s/\[\[REVERSENAME\]\]/$setdat{'showreverseheader'}/g;

	# nbV^OXg̑}
	if( $isExistHashtaglist == 1 ) {
		# nbV^OXǧfڂꍇ݂̂ɏF
		my $hashtagliststring = '<ul class="hashtaglist">';
		my @hashtagdata = split(/<<<--->>>/,$setdat{'hashtagcount'});
		foreach my $onehash (@hashtagdata) {
			# nbV^Ô̖ƃJE^𕪗
			my ($onehashname,$onehashcount) = split(/:::---:::/,$onehash);
			$hashtagliststring .= "\n<li class=\"count$onehashcount\">" . &makelinktagforhashtag( $onehashname ) . &forsafety($onehashname) . "</a><span class=\"num\">($onehashcount)</span></li>";
		}
		if( $#hashtagdata == -1 ) {
			# nbV^O1L^ĂȂ
			$hashtagliststring .= qq|<li class="notexist">nbV^O͌܂łB(܂́A܂WvĂ܂B)|;
		}
		$hashtagliststring .= "\n</ul>\n";
		$temp =~ s/\[\[HASHTAGLIST\]\]/$hashtagliststring/g;
	}

	# NCbNetH[̑}
	if( $isExistQuickpost == 1 ) {
		# NCbNetH[̌fڂꍇ݂̂ɏF
		my $quickpost;
		if( &checkpermission(1) == 0 ) {	# ǂݎp[hŔF؂mF
			# OCĂȂ
			$quickpost = q|<style type="text/css">.Login-Required { display: none; }</style>|;
		}
		else {
			# OCĂ΃tH[\
			$quickpost = &makepostform( '', '', '', '', '', '', 'QUICK' );
		}
		$temp =~ s/\[\[QUICKPOST\]\]/$quickpost/g;
	}

	# XL̎Kp̎
	if( $skindir ne '' ) {
		my $addfolder = &forsafety($skindir);

		# ?LŎn܂郊NɁAskinp[^t
		$temp =~ s/<a(.+?)href="\?(.*?)"(.*?)>/<a$1href="?skin=$addfolder&amp;$2"$3>/g;
		foreach my $onecliphtml (@cliphtmls) {
			$onecliphtml =~ s/<a(.+?)href="\?(.+?)"(.*?)>/<a$1href="?skin=$addfolder&amp;$2"$3>/g;
		}

		# CSSt@C̈ʒu
		if( $addfolder !~ m/\/$/ ) { $addfolder .= '/'; }
		$temp =~ s/<link(.+?)href="([^:]+?)"(.*?)>/<link$1href="$addfolder$2"$3>/g;		# hreflɃRL܂܂ꍇ͒ȂB
	}

	# R[h̑}
	$temp =~ s/\[\[CHARCODE\]\]/$charcode/g;

	# Nbv\邽߁AJo[XLO2idlFNbv1񂵂}łȂjɓB܂łɂׂĂ̒uς܂ĂB
	if( $temp =~ /^([\W\w]*)\[\[NEWSCLIP\]\]([\w\W]*)$/ ) {
		$coverfirst = $1;
		$coversecond = $2;
	}
	$coversecond = $coversecond . &checkhtml(($coverfirst,$coversecond));

	# \f[^1Ȃicliphtmlszɂ̓NbvĂȂƂOj
	if( $#cliphtmls < 0 ) {
		if( $clipnum > 0 ) {
			push( @cliphtmls, '<p class="nodata">w肳ꂽԍ̃Nbv݂͑܂B܂쐬ĂȂA܂͍폜܂B</p>' );
		}
		else {
			push( @cliphtmls, '<p class="nodata">\łNbv1܂łB</p>' );
			if(!( -f $bmsdata )) {
				# f[^t@C݂Ȃꍇ
				push( @cliphtmls, '<p class="nodata">f[^t@Ĉ܂łBf[^t@CAbv[hĂ邩At@Cݒ肳Ă邩mFĉB</p>' );
			}
		}
	}

	# TCg}bv[h̏ꍇ͐p^Oǉ
	if( $showmode eq 'sitemap' ) {
		$coverfirst .= '<div class="sitemappage">' . "\n";
		$coversecond = '</div>' . $coversecond;
	}

	# \
	print $coverfirst;
	print @cliphtmls;
	print $coversecond;

}
elsif( $showmode eq 'edit' ) {

	# ===========================
	# EDIT MODE
	# ===========================

	# ݌mF
	if( &checkpermission() == 0 ) {
		# mFłȂꍇFpX[h`FbN
		&passfront("?mode=edit&clip=$clipnum");
		exit;
	}

	my ( $id, $datetime, $title, $newsurl, $category, $comment ) = '';

	# VKorҏW
	my $isNew;
	if( $clipnum > 0 ) {
		# Nbv̕ҏWȂf[^𓾂
		# Ċ𓾂
		foreach my $oneclip (@xmldata) {
			$id = &fumyxmlpackage::getcontent($oneclip,'id');
			# ID̈vmF
			if( $clipnum != $id ) {
				# ĂΎT
				next;
			}
			else {
				# v瑼̏擾ă[vI
				$datetime	= &fumyxmlpackage::content_decode( &fumyxmlpackage::getcontent($oneclip,'date') );
				$title		= &fumyxmlpackage::content_decode( &fumyxmlpackage::getcontent($oneclip,'title') );
				$newsurl	= &fumyxmlpackage::content_decode( &fumyxmlpackage::getcontent($oneclip,'newsurl') );
				$category	= &fumyxmlpackage::content_decode( &fumyxmlpackage::getcontent($oneclip,'category') );
				$comment	= &fumyxmlpackage::content_decode( &fumyxmlpackage::getcontent($oneclip,'comment') );
				last;
			}
		}
		$isNew = &forsafety( "No.$id" );
	}
	else {
		# VK쐬Ȃ
		$isNew = 'NEW';
	}

	# ҏWtH[̍쐬
	my $msg = &makepostform( $id, $datetime, $title, $newsurl, $category, $comment );

	# VK쐬łȂ΍폜tH[\
	if( $id ne '' ) {
		$msg .= qq|
		<form action="./hb.cgi" method="post" class="clipedit">
			<table summary="for Delete Clip" class="alerttable">
				<tr><td>
					̃Nbv폜 
					<input type="hidden" value="admin" name="mode">
					<input type="hidden" value="trydeleteclips" name="work">
					<input type="hidden" value="$id" name="id">
					<input type="submit" value="Delete This Clip">
				</td></tr>
			</table>
		</form>
		|;
	}

	# ҏWtH[pCSSF
	my $css = '<style type="text/css">
		/* eForm */
		.edittable { border: none; border-collapse: collapse; width: 100%; }
		.edittable th, .edittable td { border-color: white; border-width: 0 0 1px 0; border-style: solid; padding: 0.2em 0.1em; }
		.edittable th { background-color: #257525; color: white; font-weight: normal; text-align: left; width: 5.5em; padding-left: 0em; font-size: 0.75em; }
		.edittable td.postbuttons { background-color: #e2f6e2; padding: 0.5em 0.3em; border-bottom: 1px solid green; }
		.edittable input[type="text"], .edittable textarea { font-size: 1em; }
		#editboxcomment,#editboxtitle,#editboxurl { width: 95%; }
		#editboxdatetime { width: 12em; }
		.demonotice { margin: 0; padding: 0; font-size: 75%; color: #cc0000; }
		.demonotice span { background-color: #cc0000; color: #ffffff; font-weight: bold; }
		/* e:폜Form */
		.alerttable { border: 2px #cc0000 solid; border-collapse: collapse; }
		.alerttable td { background-color: #ffeeee; padding: 0.5em; }
		/* e:Nbv擪ړCheckbox */
		span.checkbox { font-size: 90%; padding: 1px 0.5em; background-color: #e0ffcc; border-radius: 9px; }
		/* e:ECheckboxIvVQ */
		.suboptions { font-size: smaller; text-align: right; float: right; }
		/* e:^CAEgē */
		.timeoutmsg { margin-top: 0.5em; color: #aa0000; font-size: 80%; }
		@media all and (min-width: 600px) {
			/* eForm */
			.edittable th { padding-left: 0.3em; font-size: 1em; }
		}
	</style>';

	&showadminpage("Edit $isNew Entry",'',$msg,'CA',$css);
}
elsif( $showmode eq 'write' ) {

	# ===========================
	# WRITE MODE
	# ===========================

	my $neworedit = 'ҏW';		# ʕ񍐕\p

	# POSTŎMꍇ̂ݎs
	if( $ENV{'QUERY_STRING'} ne '' ) {
		&errormsg('GETł͌ĂяoȂGETŌĂяoƂ܂B͎s܂łB');
	}

	# f[^MemF
	my $newid = $cgi->param('id') || "";
	my $newtitle = $cgi->param('title') || "NO TITLE";
	my $newnewsurl = $cgi->param('newsurl') || "NO URL";
	my $newcomment = $cgi->param('comment') || "NO COMMENTS";
	my $newcategory = $cgi->param('category') || "0";
	my $newdate = $cgi->param('datetime') || &getdatetimestring();	# tȂΌݓL^
	my $movetoheadflag = $cgi->param('movetohead') || "0";

	# ݌mF
	if( &checkpermission() == 0 ) {
		# mFłȂꍇFG[bZ[W
		my $msg = q|
			<p style="color:red;">݌܂B(OCĂ܂)</p>
			<p>ȑOɃOCĂꍇAZbV^CAEg\܂BēxOCĒKv܂B<br />
			<small>pɂɂ̃G[\ꍇ́A^CAEgԂ̐ݒ΂Ă݂ĉB</small></p>
			<p style="margin:2em 0px 1em 0px; padding: 1em 0px 0px 0px; border-top: 1px dashed #aaaaaa; font-weight: bold;">ef[^̃Rs[F <span style="color:red; font-size:smaller;">iړOɕۑĉj</span></p>
			<p>e悤ƂeĂ܂Ȃ悤AȉɍČfڂĂ܂B܂e͎sĂ܂̂łӉBKvł΃Rs[ĎcĂAOCɍēeĉB</p>
		|;
		my $backupdata = &forsafety( "TITLE:\n" . $newtitle . "\nURL:\n" . $newnewsurl . "\nCOMMENT:\n" . $newcomment );
		$msg .= qq|<textarea rows="8" cols="30" style="width:85%; height:8em;">$backupdata</textarea>|;
		&showadminpage("No Permission",'',$msg,'L');
		exit;
	}

	# f[^ǉׂǂ̃`FbN
	my $existnewdata = 1;
	if( ($newtitle eq "NO TITLE") && ($newnewsurl eq "NO URL") && ($newcomment eq "NO COMMENTS") ) {
		# ^CgURLRgȂΒǉ̕KvȂ
		$existnewdata = 0;
	}

	my @editxmldata = ();

	# 폜ׂID𓾂
	my @ids = $cgi->param('trydelete');		# 폜ƂĎw肳ꂽIDQ
	my $eid = -1;							# ҏWΏۂƂĎw肷ID(P)
	if( $newid ne "" ) {
		# IDw肳Ă΁uҏWvȂ̂Ōf[^͍폜
		if( $movetoheadflag == 0 ) {
			# ҏWNbv擪ɈړȂꍇ
			# f[^̈ʒu͑}ʒuƂĈ
			$eid = $newid;
		}
		else {
			# ҏWNbv擪Ɉړꍇ
			# f[^͒Pɍ폜Ώۂɂ
			push( @ids, $newid );
		}
	}

	# Vc[̍쐬
	my $loopxd = -1;		# [vJE^
	my $insertline = -1;	# }ʒuێp
	foreach my $oneclip (@xmldata) {
		$loopxd++;
		my $oneid = &fumyxmlpackage::getcontent($oneclip,'id');
		my $notdel = 1;
		# ID̈vmF(폜Ώ)
		foreach my $trydel (@ids) {
			if( $flagDebug{'ShowDebugStrings'} == 1 ) { print STDERR "[Check] try:$trydel - chedkedid:$oneid<br>\n"; }
			if( $trydel == $oneid ) {
				# v폜ΏۂȂ̂ō폜(Vc[Ƀf[^ǉȂ)tO
				$notdel = 0;
				if( $flagDebug{'ShowDebugStrings'} == 1 ) { print STDERR qq|delete No.$oneid<br>|; }
			}
		}
		# ID̈vmF(ҏWΏ)
		if( $eid == $oneid ) {
			# f[^̑ɑ}ʒuʗp̃_~[f[^Ă
			push(@editxmldata , "_INSERT_EDITED_CLIP_HERE_" );
			# ̈ʒu(}ʒu)LĂ
			$insertline = $loopxd;
			# f[^͒ǉȂ(폜)tO
			$notdel = 0;
		}

		# vȂ(폜ΏۂłȂ)̂܂ܐVc[Ƀf[^ǉ
		if( $notdel == 1 ) {
			push(@editxmldata , $oneclip );
			if( $flagDebug{'ShowDebugStrings'} == 1 ) { print STDERR qq|copy No.$oneid<br>|; }
		}
	}

	# VK쐬̏ꍇFIDԍ̐
	if( $newid eq "" ) {
		my $maxid = 0;
		foreach my $oneclip (@xmldata) {
			if( &fumyxmlpackage::getcontent($oneclip,'id') > $maxid ) {
				$maxid = &fumyxmlpackage::getcontent($oneclip,'id');
			}
		}
		$newid = $maxid + 1;	# VKGgIDԍ
		$neworedit = 'VKe';	# ʕ񍐕\p
	}

	# f[^ǉ
	my $allowand  = $cgi->param('allowand') || '0';		# ̎QƂ邩ǂ̎wi0:NO,1:YESj
	my $allowtag = $cgi->param('allowtag') || '0';		# a^O邩ǂ̎wi0:NO,1:YESj
	if( $flagDemo{'NotAllowHtml'} != 0 ) {
		$allowtag = 0;	# 
	}
	if( $existnewdata == 1 ) {
		# VKf[^XML̍쐬
		my $newxmlline = &fumyxmlpackage::makerecord( 'clip',
			&fumyxmlpackage::makeelement('date'	,	$newdate	, 0, 0 ) , 
			&fumyxmlpackage::makeelement('id'	,	$newid		, 0, 0 ) ,
			&fumyxmlpackage::makeelement('title',	$newtitle	, $allowand, $allowtag) , 
			&fumyxmlpackage::makeelement('category',$newcategory, 0, 0 ) , 
			&fumyxmlpackage::makeelement('newsurl',	$newnewsurl	, 0, 0 ) , 
			&fumyxmlpackage::makeelement('comment',	$newcomment	, $allowand, $allowtag)
		);
		# f[^ǉ
		if( $movetoheadflag == 0 && $insertline >= 0 ) {
			# ҏWNbv̈ʒuɑ}ꍇi}ʒuێĂꍇj
			$editxmldata[$insertline] =~ s/_INSERT_EDITED_CLIP_HERE_/$newxmlline/;
		}
		else {
			# ҏWNbv擪ɑ}ꍇ
			unshift(@editxmldata , $newxmlline);
		}
	}

	# XML쐬
	&fumyxmlpackage::XMLout( $bmsdata, 'newsclips', $charcode, @editxmldata );

	# f[^t@Cǂݒ
	@xmldata = &fumyxmlpackage::XMLin($bmsdata,'clip');

	# I\
	my $msg;
	if( $existnewdata == 1 ) {
		# ǉEҏW̏ꍇF
		my $addposition;
		if( $insertline >= 0 ) { $addposition = '(̌fڈʒuێ)'; }
		else 				   { $addposition = '(擪Ɍf)'; }
		$msg = qq|
			<p>No.$newid ̃Nbv $neworedit ܂B$addposition</p>
			<ul>
				<li><a href="?clip=$newid$queryforapplyskin">No.$newid ̃Nbv\\\</a></li>
				<li><a href="?mode=edit&amp;clip=$newid$queryforapplyskin">No.$newid ̃NbvēxҏW</a></li>
			</ul>
			
		|;
	}
	else {
		if( $ids[0] ne '' ) {
			# 폜̏ꍇFiҏWł폜͂邯ǂ̏ꍇ͕\ȂB킵Bj
			$msg = qq|
				<p>ȉ̃Nbv폜܂B</p>
				<table class="managetable" cellpadding="0"><tr><th>No.</th></tr>\n
			|;
			foreach my $onedelid ( @ids ) {
				$msg .= qq|<tr><td>No.$onedelid</td></tr>|;
			}
			$msg .= qq|</table>\n|;
		}
		else {
			# ǉ폜ĂȂꍇFiɓe{^ꍇACGĨp[^蓮œ͂ꍇȂǂɎs\Bj
			$msg = qq|<p>e܂Bf[^t@CtbV܂B</p>|;
		}
	}

	# ăJEg
	if( $existnewdata == 1 || $ids[0] ne '' ) {
		$msg .= '<div style="margin-top:2em; color:gray;"><p style="margin:0;">tF</p><ul style="font-size:0.8em; margin-top:0;">';
		# JeSďWv
		&categorycounter();
		$msg .= '<li>JeSYďWv܂B</li>';
		# NďWv
		&datadatecounter();
		$msg .= '<li>NʊYďWv܂B</li>';
		# nbV^ÕtbVKvۂΎ{inbV^OƂĂ͐ĂȂu#vLꍇɂs邪A܂Q͂Ȃ낤B^^;j
		if( $newcomment =~ m/#/ || $ids[0] ne '' ) {
			# nbV^O̍ăJEg𒼐ڎs
			my $retdc = &datahashcounter();
			$msg .= '<li>nbV^O̊YďWv܂B</li>';
		}
		$msg .= '</ul></div>';
	}

	if( $flagDebug{'ShowDebugStrings'} == 1 ) {
		print STDERR qq|<hr><p>[$newid] Title:$newtitle<br>$newnewsurl [CAT:$newcategory]</p><p>$newcomment</p><p>$newdate</p><hr>\n|;
	}

	&showadminpage('EDITED CLIPS','',$msg,'CA');
}
elsif( $showmode eq 'admin' ) {

	# ===========================
	# ADMIN MODE
	# ===========================

	# f[^MemF
	my $workkind = $cgi->param('work') || "";

	# F؃`FbNOɎs鏈QF
	if( $workkind eq 'logout' ) {
		# OAEg
		my $res = &logout();
		my $msg = qq|<p>OAEg܂B<!-- Logout Sign: $res --> - <a href="?mode=admin">ăOC</a></p>\n|;
		&showadminpage('LOGOUT','',$msg,'C');
		exit;
	}

	# ANZX̊mF
	if( &checkpermission() == 0 ) {
		# mFłȂꍇFpX[h`FbN
		if( $workkind eq '' ) {
			&passfront('?mode=admin');
		}
		elsif( ( $workkind eq 'setting' ) && ( $showpage ne '' ) ) {
			&passfront("?mode=admin&work=setting&page=$showpage");
		}
		else {
			&passfront("?mode=admin&work=$workkind");	# sȕ񂪎w肳Ăꍇłpassfront̏o͑OɑΏB
		}
		exit;
	}

	# e
	if( $workkind eq "" ) {
		# Ǘj[
		my $sessionmsg;
		if( $keepsession == 1 ) {
			my $timeoutlim = &sectotimestring( $sessiontimeout );
			$sessionmsg = qq|OAEgɃuEUIƁAZbVL($timeoutlim)܂ł̓OCԂێݒɂȂĂ܂B|;
		}
		else {
			$sessionmsg = qq|NbNȂĂAuEUIƎOAEgݒɂȂĂ܂B|;
		}
		my $msg = qq|
		<p>ƓeIĉB</p>
		<div class="systemmenubox">
			<div class="systemmenucolumn">
				<p class="systemmenucategory">X̍ƁF</p>
				<ul class="systemmenu">
					<li><a href="?mode=edit$queryforapplyskin"><span class="jp">VKe</span><span class="en">Make New Clip</span></a></li>
					<li><a href="?mode=admin&amp;work=manage$queryforapplyskin"><span class="jp">Nbv폜/ҏW</span><span class="en">Manage Clips</span></a></li>
				</ul>
				<p class="systemmenucategory">eiXF</p>
				<ul class="systemmenu">
					<li><a href="?mode=admin&amp;work=setting$queryforapplyskin"><span class="jp">ݒ</span><span class="en">Settings</span></a></li>
					<li><a href="?mode=admin&amp;work=changepass$queryforapplyskin"><span class="jp">pX[hύX</span><span class="en">Change Password</span></a></li>
					<li><a href="?mode=admin&amp;work=recount$queryforapplyskin"><span class="jp">NbvăJEg</span><span class="en">Recount Clips</span></a></li>
					<li><a href="?mode=admin&amp;work=backup$queryforapplyskin"><span class="jp">f[^obNAbv</span><span class="en">Backup Data</span></a></li>
					<li><a href="?mode=admin&amp;work=skinlist"><span class="jp">ʃXL̈ꎞKp</span><span class="en">Apply Another Skin</span></a></li>
				</ul>
				<p class="systemmenucategory">OAEgF</p>
				<ul class="systemmenu">
					<li><a href="?mode=admin&amp;work=logout$queryforapplyskin"><span class="jp">OAEg</span><span class="en">Logout</span></a></li>
				</ul>
				<p class="sessionguide">$sessionmsg</p>
			</div>
			<div class="systemmenucolumn">
				<p class="systemhelpbox"><span class="helpboxtitle">CGIɂ</span> <a href="https://www.nishishi.com/cgi/newsclip/">ŐVłmF</a><br><a href="https://www.nishishi.com/cgi/newsclip/#howtouse">ICwvǂ</a><br><a href="https://www.nishishi.com/cgi/newsclip/#feedback">ӌEz𑗂</a></p>
			</div>
		</div>
		|;
		if( &checkpass('') == 1 ) {
			# pX[hݒȂݒ𑣂bZ[W\
			$msg .= '<p style="color:#dd0000;">pX[hݒłB܂́Au<strong>pX[hύX</strong>vj[găpX[hݒ肵ĉB</p>';
		}

		# Ǘj[pCSSF
		my $css = '<style type="text/css">
			/* Ǘ:BOX */
			.note { font-size: 0.8em; background-color: #eee; padding: 0.25em; }
			/* Ǘ:OAEg{^(1J) */
			.sessionguide { font-size: 80%; line-height: 1.1; margin: 1em 0; padding: 0.3em 0 0 0; color: #555; }
			/* CGIɂBOX */
			.systemhelpbox { width: 12em; border: 1px solid green; background-color:#ffffcc; border-radius: 6px; margin: auto; padding: 0.3em; text-align: center; line-height: 1.5; }
			.systemhelpbox .helpboxtitle { display:block; background-color:green; color:white; margin-bottom: 0.5em; border-radius:0.3em; }
			@media all and (min-width: 600px) {
				/* Ǘ */
				.systemmenubox { display: table; width: 100%; }
				.systemmenucolumn { display: table-cell; vertical-align: top; }
			}
		</style>';

		&showadminpage('ADMIN MODE','',$msg,'C',$css);
	}
	elsif( $workkind eq 'manage' ) {
		# Nbv̊Ǘ(폜)
		my $msg = qq|
			<p>NbvǗ܂B</p>
			<ul>
				<li>Nbv<strong>폜</strong>ꍇ́A[No.Ƀ`FbN<input type="checkbox" checked>āAŉ́uINbv폜v{^ĉBĩNbv𓯎ɍ폜ł܂Bj</li>
				<li>Nbv<strong>ҏW</strong>ꍇ́AE[̕ҏWɂ<span class="smallbutton">Edit.00</span>{^NbNĉB</li>
				<li>Nbv<strong>\\\</strong>ꍇ́A^CgNbNĉBĩNbvPƂ̃y[WɈړ܂Bj</li>
			</ul>
			<form action="./hb.cgi" method="post">
				<table class="managetable" cellpadding="0"><tr><th>No.</th><th>^Cg</th><th>t</th><th>JeS</th><th>ҏW</th></tr>
		|;
		my $totalclips = 0;
		foreach my $oneclip (@xmldata) {
			my ($id,$datetime,$title,$category);
			$id 		= &forsafety( &fumyxmlpackage::getcontent($oneclip,'id') );
			$datetime	= &forsafety( &fumyxmlpackage::getcontent($oneclip,'date') );
			$title		= &forsafety( &fumyxmlpackage::getcontent($oneclip,'title') );
			$category	= &forsafety( $categories[&fumyxmlpackage::getcontent($oneclip,'category')] );
			
			$msg .= qq|<tr><td class="mtid"><label class="choiceid"><input type="checkbox" name="id" value="$id">$id</label></td><td class="mttitle"><a href="?clip=$id">$title</a></td><td class="mttime">$datetime</td><td class="mtcat">$category</td><td><a href="?mode=edit&amp;clip=$id" class="smallbutton">Edit.$id</a></td></tr>\n|;
			$totalclips++;
		}
		if( $totalclips == 0 ) {
			# Nbv1Ȃ
			$msg .= qq|<tr><td colspan="5">Nbv1쐬Ă܂B</td></tr>\n|;
		}
		$msg .= qq|
				</table>
				<input type="hidden" value="admin" name="mode">
				<input type="hidden" value="trydeleteclips" name="work">
				$inputtagforapplyskin
				<input type="submit" value="INbv폜"><br>
			</form>
			<p style="text-align:right; font-size:0.8em;">݂Nbv́Av<b style="margin:0 3px;">$totalclips</b>łB</p>
		|;

		# CSS
		my $css = '<style tyle="text/css">.choiceid { cursor:pointer; } .choiceid:hover { background-color:#eff; color:blue; }</style>';

		&showadminpage('MANAGE CLIPS','',$msg,'CA',$css);
	}
	elsif( $workkind eq 'trydeleteclips' ) {
		# Nbv̍폜(TRY)
		my @ids = $cgi->param('id');
		my $msg;

		if( $flagDebug{'ShowDebugStrings'} == 1 ) {
			my $trydeletes = join( "," , @ids );
			print STDERR "[TRYDELETES] $trydeletes\n\n";
		}

		if( $ids[0] ne '' ) {
			# 폜₪1ȏ㑶݂
			$msg = qq|
				<p>ȉ̃Nbv폜܂B낵łH</p>
				<form action="./hb.cgi" method="post">
					<table class="managetable" cellpadding="0"><tr><th></th><th>^Cg</th><th>t</th><th>JeS</th></tr>
			|;
			foreach my $oneclip (@xmldata) {
				foreach my $tryid ( @ids ) {
					if( $tryid eq &fumyxmlpackage::getcontent($oneclip,'id') ) {
						# 폜ƈv
						my ($id,$datetime,$title,$category);
						$id			= &forsafety( &fumyxmlpackage::getcontent($oneclip,'id') );
						$datetime	= &forsafety( &fumyxmlpackage::getcontent($oneclip,'date') );
						$title		= &forsafety( &fumyxmlpackage::getcontent($oneclip,'title') );
						$category	= &forsafety( $categories[&fumyxmlpackage::getcontent($oneclip,'category')] );

						$msg .= qq|<tr><td>No.$id<input type="hidden" value="$id" name="trydelete"></td><td><a href="?clip=$id" target="_blank">$title</a></td><td>$datetime</td><td>$category</td></tr>|;
					}
				}
			}
			$msg .= qq|
					</table>
					<input type="hidden" value="write" name="mode">
					$inputtagforapplyskin
					<input type="submit" value="폜">
					&nbsp;<input type="button" value="~Ė߂" onClick="history.back();"><br>
				</form>
			|;
		}
		else {
			# 폜₪1Ȃ
			$msg = qq|<p>폜Nbv1IĂ܂B</p>|;
		}

		&showadminpage('DELETE CLIPS','',$msg,'CA');
	}
	elsif( $workkind eq 'setting' ) {
		# ------------------------
		# ݒt@C̍XV(FORM)
		# ------------------------
		my $cats = join("\n",@categories);		# JeS(ǂݍݎ_ŃGXP[vς)
		$setdat{'freespace'} =~ s/<br>/\r\n/g;	# t[Xy[X̉sϊ

		# nbV^Oꗗ̌fڏ̐ݒ󋵂𔽉f
		my @hashtagsort = ('','','','','');
		$hashtagsort[$setdat{'hashtagsort'}] = 'selected';

		# ǂދ@\̐ݒ󋵂𔽉f
		my @readmoreonoff1 = ('','');	$readmoreonoff1[$setdat{'readmoreonoff1'}] = 'selected';
		my @readmoreonoff2 = ('','');	$readmoreonoff2[$setdat{'readmoreonoff2'}] = 'selected';
		my @readmoreonoff3 = ('','');	$readmoreonoff3[$setdat{'readmoreonoff3'}] = 'selected';
		my @readmoreonoff4 = ('','');	$readmoreonoff4[$setdat{'readmoreonoff4'}] = 'selected';
		my @readmoreonoff5 = ('','');	$readmoreonoff5[$setdat{'readmoreonoff5'}] = 'selected';
		my @readmoreonoff6 = ('','');	$readmoreonoff6[$setdat{'readmoreonoff6'}] = 'selected';
		my @readmorehtmltagselect = ('','','');	$readmorehtmltagselect[$setdat{'readmorehtmltag'}] = 'selected';
		my @readmorecloseuse = ('','');	$readmorecloseuse[$setdat{'readmorecloseuse'}] = 'selected';	# ރ{^̗L

		# ZbVێ̒Pʐݒ󋵂𔽉f
		my @sessiontluset = ('','');
		$sessiontluset[$setdat{'sessiontimeunit'}] = 'selected';
		# ZbVێݒɂ郁bZ[W쐬
		my $sessionkeepmsg = '<p class="inputinfo alertinfo">uEUI<strong class="important">OAEgݒɂȂĂ</strong>߁AL̐ݒɈӖ͂܂B(uEUIĂOCԂێł悤ݒύXɂ́ACGI\[X̐ݒ荀ڂ̒lύXĉB)</p>';
		if( $keepsession == 1 ) {
			$sessionkeepmsg = '<p class="inputinfo">uEUIĂAL̎Ԃo߂܂ł̓OCԂێ܂B(uEȔIƓɎOAEgꍇ́ACGI\[X̐ݒ荀ڂ̒lύXĉB)</p>';
		}

		# ҏWNbv̌fڏݒ𔽉f
		my $clipremoval0 = '';
		my $clipremoval1 = '';
		if( $setdat{'clipremoval'} == 1 ) {
			$clipremoval1 = "checked";
		}
		else {
			$clipremoval0 = "checked";
		}

		# `FbN{bNX(1:ON/0:OFFŋL^)p̑l
		$setdat{'urlautolink'}			= &getattributeforcheckbox($setdat{'urlautolink'});
		$setdat{'postformItemNo'}		= &getattributeforcheckbox($setdat{'postformItemNo'});
		$setdat{'postformItemTitle'}	= &getattributeforcheckbox($setdat{'postformItemTitle'});
		$setdat{'postformItemClipUrl'}	= &getattributeforcheckbox($setdat{'postformItemClipUrl'});
		$setdat{'postformItemCategory'}	= &getattributeforcheckbox($setdat{'postformItemCategory'});
		$setdat{'postformItemComment'}	= &getattributeforcheckbox($setdat{'postformItemComment'});
		$setdat{'postformItemDate'}		= &getattributeforcheckbox($setdat{'postformItemDate'});
		$setdat{'postformItemOptions'}	= &getattributeforcheckbox($setdat{'postformItemOptions'});
		$setdat{'postformTimeoutGuide'}	= &getattributeforcheckbox($setdat{'postformTimeoutGuide'});
		$setdat{'datelistShowYear'}	= &getattributeforcheckbox($setdat{'datelistShowYear'});

		# cccccccccccccccccc
		# ͗Ɍfڂϐ̈ꊇGXP[v
		foreach my $key ( keys(%setdat) ){
			$setdat{$key} = &forsafety( $setdat{$key} );
		}

		# I^u̐ݒ
		my @checkedtab = ('','','','','','');
		if( $showpage == 2 ) { $checkedtab[2] = 'checked'; }
		else { $checkedtab[1] = 'checked'; }	# ftHgȂ擪^u(1)J

		# ccccccccc
		# ݒtH[̐
		# ccccccccc
		# HTML:
		my $msg = qq|
			<p>
				CGI̓ݒs܂BKvȐݒύXAŉ́uݒۑv{^NbNĉBie^úAݒ̕ۑOɐ؂ւ܂Bj<br />
			</p>
			<form action="./hb.cgi" method="post">
				<input type="radio" name="tabset" class="tabcheck" id="tabcheck1" $checkedtab[1]><label for="tabcheck1" class="tab" id="tab1">y[W<span class="longtabname">̕\\\</span></label>
				<input type="radio" name="tabset" class="tabcheck" id="tabcheck4" $checkedtab[4]><label for="tabcheck4" class="tab" id="tab4">JeS</label>
				<input type="radio" name="tabset" class="tabcheck" id="tabcheck5" $checkedtab[5]><label for="tabcheck5" class="tab" id="tab5">Nbv<span class="longtabname">̕\\\</span></label>
				<input type="radio" name="tabset" class="tabcheck" id="tabcheck2" $checkedtab[2]><label for="tabcheck2" class="tab" id="tab2">t[<span class="longtabname">Xy[X</span></label>
				<input type="radio" name="tabset" class="tabcheck" id="tabcheck3" $checkedtab[3]><label for="tabcheck3" class="tab" id="tab3">VXe<span class="longtabname">ݒ</span></label>

				<div class="tabcontent" id="tabcontent1">
					<fieldset id="fieldpage">
						<legend>yy[W̕\\\z</legend>
						<p id="clipsperpage">
							1y[W̕\\\NbvF
						</p>
						<ul class="list">
							<li><label>ʏ\\\̏ꍇF<input type="text" value="$setdat{'entryperpage'}" name="entryperpage" size="5"></label> <span class="inputguide">1ȏ̐Ŏw肵ĉB</span></li>
							<li><label>TCg}bv̏ꍇF<input type="text" value="$setdat{'entrypersitemappage'}" name="entrypersitemappage" size="5"></label> <span class="inputguide">1ȏ̐Ŏw肵ĉB</span></li>
						</ul>
						<p id="pagelinkstrings" class="withseparator">
							y[WړNɕ\\\镶F <span class="inputguide">͂Ȃ΁AW̒lݒ肳܂BHTMLgpB</span><br>
						</p>
						<ul class="list">
							<li><label>úvF<input type="text" value="$setdat{'plinknext'}" name="plinknext"></label><span class="inputguide">(WFNext)</span></li>
							<li><label>uÓvF<input type="text" value="$setdat{'plinkprev'}" name="plinkprev"></label><span class="inputguide">(WFPrev)</span></li>
							<li><label>uNbvvF<input type="text" value="$setdat{'plinkunit'}" name="plinkunit"></label><span class="inputguide">(WFClips)</span></li>
							<li><label>E()F<input type="text" value="$setdat{'plinkarrownext'}" name="plinkarrownext"></label><span class="inputguide">(WF&raquo;u&amp;raquo;v)</span></li>
							<li><label>(߂)F<input type="text" value="$setdat{'plinkarrowprev'}" name="plinkarrowprev"></label><span class="inputguide">(WF&laquo;u&amp;laquo;v)</span></li>
							<li><label>uŏɖ߂vF<input type="text" value="$setdat{'plinkbacktohome'}" name="plinkbacktohome"></label><span class="inputguide">(WFS̕\\\ɖ߂)</span></li>
							<li><label>ey[Wԍ̍ɑ}LF<input type="text" value="$setdat{'pagenumbracket1'}" name="pagenumbracket1"></label><span class="inputguide">(WFȂ)</span></li>
							<li><label>ey[Wԍ̉Eɑ}LF<input type="text" value="$setdat{'pagenumbracket2'}" name="pagenumbracket2"></label><span class="inputguide">(WFȂ)</span></li>
							<li><label>y[WړNƖ߂郊NƂ̋EF<input type="text" value="$setdat{'plinkseparator'}" name="plinkseparator"></label><span class="inputguide">(WFsu&lt;br&gt;v)</span></li>
						</ul>
						<p>
							<span class="inputguide">œ͂Lu&lt;vu&gt;vȂǂHTML^OƂĂ̂܂܏o͂_ɂӉB</span>
						</p>
						<p id="headerstrings" class="withseparator">
							ʂȕ\\\Ƀwb_ɒǉ镶F <span class="inputguide">͂Ȃ΁AW̒lݒ肳܂B</span><br>
						</p>
						<ul class="list">
							<li><label>TCg}bv\\\F<input type="text" value="$setdat{'sitemappreheader'}" name="sitemappreheader"></label><span class="inputguide">(WFuTCg}bvv)</span></li>
							<li><label>tł̕\\\F<input type="text" value="$setdat{'showreverseheader'}" name="showreverseheader"></label><span class="inputguide">(WFutv)</span></li>
						</ul>
					</fieldset>
					<fieldset id="fixedclip">
						<legend>ywNbv̐擪Œ\\\z</legend>
						<p id="fixedclipnum">
							ɐ擪ɌŒ肵ĕ\\\Nbv
						</p>
						<ul>
							<li>No.<input type="text" value="$setdat{'fixedclipnum'}" name="fixedclipnum" size="5"> <span class="inputguide">擪ɌŒ肵Ȃꍇ́u0v͂ĉB</span></li>
						</ul>
					</fieldset>
					<fieldset id="fieldhash">
						<legend>ynbV^O̕\\\z</legend>
						<p id="categories">
							nbV^Oꗗ\\\̌fڏ:
						</p>
						<ul>
							<li>
								<select name="hashtagsort"><option value="0" $hashtagsort[0]>0:o</option><option value="1" $hashtagsort[1]>1:ȏiʂȂoj</option><option value="2" $hashtagsort[2]>2:ȍȂiʂȂoj</option><option value="3" $hashtagsort[3]>3:ȏiʂȂ當R[hj</option><option value="4" $hashtagsort[4]>4:ȍȂiʂȂ當R[hj</option></select><br>
								<span class="inputguide">uovƂ́AVeÂe֌đۂɌ̂ƂłB(ěÂł͂܂)</span>
								<!-- Ȍ --><input type="hidden" name="befhashts" value="$setdat{'hashtagsort'}">
							</li>
						</ul>
					</fieldset>
					<fieldset id="clipoptions">
						<legend>yetXgz</legend>
						<ul>
							<li><label><input type="checkbox" name="datelistShowYear" value="1" $setdat{'datelistShowYear'}>etXg(NXg)ɁuNPƁv̊Kw</label></li>
						</ul>
						<!-- Ȍ --><input type="hidden" name="befdatelistSY" value="$setdat{'datelistShowYear'}">
					</fieldset>
				</div>
				<div class="tabcontent" id="tabcontent4">
					<fieldset id="fieldcategory">
						<legend>yJeS̕\\\z</legend>
						<p id="categories">
							JeSXg: <span class="inputguide">1sڂ́uJeSȂv\\\ɂĉBiJeSꗗɂ͕\\\܂Bj</span><br>
							<textarea name="categories" cols="20" rows="6" id="catlist">$cats</textarea><br>
						</p>
					</fieldset>
				</div>
				<div class="tabcontent" id="tabcontent5">
					<fieldset id="clipoptions">
						<legend>yRg{̕\\\z</legend>
						<ul>
							<li><label><input type="checkbox" name="urlautolink" value="1" $setdat{'urlautolink'}>URLŃNɂ</label></li>
						</ul>
					</fieldset>
					<fieldset id="readmorefunction">
						<legend>yǂދ@\\\z</legend>
						<p id="readmoreonoff">
							uǂށv@\\\̗L/ʕʂɐݒ:
						</p>
						<ul class="list">
							<li>W̕\\\F	<select name="readmoreonoff1"><option value="0" $readmoreonoff1[0]>~ iɑS\\\j</option><option value="1" $readmoreonoff1[1]> L</option></select></li>
							<li>JeS\\\F	<select name="readmoreonoff2"><option value="0" $readmoreonoff2[0]>~ iɑS\\\j</option><option value="1" $readmoreonoff2[1]> L</option></select></li>
							<li>Sʕ\\\F	<select name="readmoreonoff3"><option value="0" $readmoreonoff3[0]>~ iɑS\\\j</option><option value="1" $readmoreonoff3[1]> L</option></select></li>
							<li>et\\\F	<select name="readmoreonoff4"><option value="0" $readmoreonoff4[0]>~ iɑS\\\j</option><option value="1" $readmoreonoff4[1]> L</option></select></li>
							<li>nbV^OF	<select name="readmoreonoff5"><option value="0" $readmoreonoff5[0]>~ iɑS\\\j</option><option value="1" $readmoreonoff5[1]> L</option></select></li>
							<li>PƃNbv\\\F	<select name="readmoreonoff6"><option value="0" $readmoreonoff6[0]>~ iɑS\\\j</option><option value="1" $readmoreonoff6[1]> L</option></select></li>
						</ul>
						<p class="inputguide">
							LŁuLvɐݒ肵ʂł́AeRgɋ؂蕶u&lt;&gt;v܂܂ĂƂAJavaScriptLȊł́uǂށv{^\\\A㑱̓eB܂B(؂蕶1Nbvɉxłg܂B) uvɐݒ肵ʂł͍ŏS\\\܂A؂蕶u&lt;&gt;v͕̂\\\܂B<br>
							uǂށv@\\\SɕsvȂA<strong>Sڂ</strong>uvɐݒ肵ĂƁA]vȑȗ邽߁ANbv̕\\\xȂ܂BiASڂuvɐݒ肷ƁARg{ɋ؂蕶u&lt;&gt;vLĂꍇA؂蕶u&lt;&gt;v͏ꂸɂ̂܂܏o͂܂Bj<br>
						</p>
						<p id="readmorehtml" class="withseparator">
							uǂށv@\\\̕\\\@
						</p>
						<ul class="list">
							<li>WJ{^(N)̃xF <input type="text" value="$setdat{'readmorelinklabel'}" name="readmorelinklabel" size="20"> <span class="inputguide">1ȏKvłB(W:uǂށv)</span></li>
							<li>B𕢂HTMLvfF <select name="readmorehtmltag"><option value="0" $setdat{'readmorehtmltag'}select[0]>spanvf</option><option value="1" $setdat{'readmorehtmltag'}select[1]>divvf</option><option value="2" $setdat{'readmorehtmltag'}select[2]>pvf</option></select></li>
						</ul>
						<p class="inputguide">
							B𕢂HTMLvfupvudivvɂꍇ́AXLHTML̏ɂĂHTML̕@\\\܂BʂȈӐ}Ȃ΁uspanv̐ݒŎgƂߒv܂B<br>
						</p>
						<p id="readmoreback" class="withseparator">
							ǂ񂾌uĂяށv@\\\̕\\\@
						</p>
						<ul class="list">
							<li>ǂ񂾌ɁuĂяށv߂̃{^ <select name="readmorecloseuse"><option value="0" $readmorecloseuse[0]>\\\Ȃ</option><option value="1" $readmorecloseuse[1]>\\\</option></select>B</li>
							<li>ރ{^(N)̃xF <input type="text" value="$setdat{'readmorecloselabel'}" name="readmorecloselabel" size="20"> <span class="inputguide">1ȏKvłB(W:uށv)</span></li>
						</ul>
					</fieldset>
				</div>
				<div class="tabcontent" id="tabcontent2">
					<!-- fieldset id="fielddisplay" -->
						<!-- legend>y̑̕\\\z</legend -->
						<p id="freespace">
							t[Xy[X: <span class="inputguide">HTMLgpBsƎۂ̕\\\łs܂B</span><br>
							<textarea name="freespace" cols="45" rows="10" id="fsp">$setdat{'freespace'}</textarea><br>
						</p>
						<p class="skinguide">
							L̃t[Xy[Xɓ͂éAXLt@C <strong>[[FREESPACE]]</strong> ƋLqʒuɑ}܂B<br>
							ڂdĺA<a href="https://www.nishishi.com/cgi/newsclip/#howtouse">ICwv</a>́u<a href="https://www.nishishi.com/cgi/newsclip/#specification-freespace">t[Xy[X̏</a>vQƉB<br>
							<button href="#freespaceDetailGuide" onclick="document.getElementById('freespaceDetailGuide').style.display='block'; this.style.display='none'; return false;">ȈՃwv</button>
						</p>
						<p class="skinguide hidedetail" id="freespaceDetailGuide">
							t[Xy[Xɂ́A؂蕶 <input type="text" value="&lt;&gt;" style="width:3em;" readonly> g܂Bgpɐ͂܂B(pœ)<br>
							XL <strong>[[FREESPACE:<strong class="important">0</strong>]]</strong> ƋLq΁A<strong class="important">擪</strong>ŏ̋؂蕶܂ł̓e}܂B<br>
							XL <strong>[[FREESPACE:<strong class="important">1</strong>]]</strong> ƋLq΁A<strong class="important">1ڂ̋؂蕶</strong>̋؂蕶܂ł̓e}܂B<br>
							XL <strong>[[FREESPACE:5<strong class="important">/IF-HOME</strong>]]</strong> ƋLq΁A<strong>5ڂ̋؂蕶</strong>̋؂蕶܂ł̓e<strong class="important">HOMEy[Wł̂</strong>}܂B<br>
							XL <strong>[[FREESPACE:6<strong class="important">/IF-CATEGORY:3</strong>]]</strong> ƋLq΁A<strong>6ڂ̋؂蕶</strong>̋؂蕶܂ł̓e<strong class="important">3Ԗڂ̃JeSɌ肵ꗗy[Wł̂</strong>}܂B<br>
						</p>
					<!-- /fieldset -->
				</div>
				<div class="tabcontent" id="tabcontent3">
					<fieldset id="posttableoption">
						<legend>yNbveʂ̐ݒz</legend>
						<p id="clipurlinputs">
							eʂɕ\\\͍ڂ̑IF<br>
						</p>
						<ul class="list">
							<li><label><input type="checkbox" name="postformItemNo"			value="1" $setdat{'postformItemNo'}			>Edit No\\\</label> <span class="inputguide">QUICKetH[ł͏ɕ\\\܂B</span></li>
							<li><label><input type="checkbox" name="postformItemTitle"		value="1" $setdat{'postformItemTitle'}		>^Cg\\\</label></li>
							<li><label><input type="checkbox" name="postformItemClipUrl"	value="1" $setdat{'postformItemClipUrl'}	>CLIP URL\\\</label></li>
							<li><label><input type="checkbox" name="postformItemCategory"	value="1" $setdat{'postformItemCategory'}	>JeS\\\</label></li>
							<li><label><input type="checkbox" name="postformItemComment"	value="1" $setdat{'postformItemComment'}	>Rg\\\</label></li>
							<li><label><input type="checkbox" name="postformItemDate"		value="1" $setdat{'postformItemDate'}		>e\\\</label> <span class="inputguide">\\\ƁAɓeuԂ̓L^܂B</span></li>
							<li><label><input type="checkbox" name="postformItemOptions"	value="1" $setdat{'postformItemOptions'}	>eIvVQ\\\</label> <span class="inputguide">\\\ƁASIvVOFFɐݒ肵̂ƓʂɂȂ܂B</span></li>
							<li><label><input type="checkbox" name="postformTimeoutGuide"	value="1" $setdat{'postformTimeoutGuide'}	>^CAEgē\\\</label> <span class="inputguide">Ǘʂ̓etH[ł͏ɕ\\\܂B</span></li>
						</ul>
						<!-- ݒ̍폜 -->
						<input type="hidden" name="hideclipurlinput" value=""><!-- CLIP URL͗\\\ȂB -->
						<p class="inputguide">
							j[XNbvprł͂ȂȈՃuOc[ƂĎgpꍇɂ́AĂuCLIP URLv͕͗svł傤B̂悤ȏꍇɔ\\\ɐݒ肵ĉB<br>
							L̐ݒ́uǗʂɂ铊etH[vƁuNbv\\\y[Wɕ\\\łQUICKetH[vɋʂ̐ݒłB<br>
							u^CgvEuCLIP URLvEuRgv3ڂׂĂ\\\ɂƁAVKe͈؂łȂȂ܂B<br>
						</p>
						<p id="textareasize" class="withseparator">
							Rg͗̒(ҏẄ̕\\\s)F<br>
						</p>
						<ul class="list">
							<li><label>Ǘʓ̃tH[̕ҏWF<input type="text" value="$setdat{'textareasizenormal'}" name="textareasizenormal" size="4">s</label> <span class="inputguide">(W:9s)</span></li>
							<li><label>NCbNetH[̕ҏWF<input type="text" value="$setdat{'textareasizequick'}"  name="textareasizequick"  size="4">s</label> <span class="inputguide">(W:7s)</span></li>
						</ul>
						<p class="inputguide">
							𓊍epxȂ璷߂ɐݒ肵ĂƎg₷ł傤Bg̊ɂĂ(sԃTCỶe)ݒlȂsŕ\\\܂Aۂ̕\\\sƔrĒlĉB
						</p>
					</fieldset>
					<fieldset id="fieldoption">
						<legend>yeIvVz</legend>
						<p id="clipremoval">
							eCNbv̌fڏF<br>
						</p>
						<ul>
							<li><label><input type="radio" name="clipremoval" value="1" $clipremoval1>CNbv(VKê悤)擪ɌJグ</label></li>
							<li><label><input type="radio" name="clipremoval" value="0" $clipremoval0>NbvCĂǍfڈʒu()ێ</label></li>
						</ul>
						<p id="options" class="withseparator">
							Nbv̕ҏWIvVF<br>
						</p>
						<ul>
							<li><input type="checkbox" name="allowtag" id="allowtag" value="checked" $setdat{'allowtag'}><label for="allowtag">HTML^O̎gpݒɂ</label></li>
							<li><input type="checkbox" name="allowand" id="allowand" value="checked" $setdat{'allowand'}><label for="allowand">Ɏ̎QƂ̎gpݒɂ</label></li>
						</ul>
						<p class="inputguide">
							ł̐ݒɊ֌WȂAۂ̓eɂ͐ݒꎞIɕύXł܂B
						</p>
					</fieldset>
					<fieldset id="fieldsystemset">
						<legend>yVXe֘Az</legend>
						<p id="sessiontimelimit">
							OCԂێF <span class="inputguide">ŒZ0.5ԁEŒ366iW1.5ԁj</span><br>
						</p>
						<ul>
							<li>
								<input type="text" value="$setdat{'sessiontimenum'}" name="sessiontimenum" size="7">
								<select name="sessiontimeunit"><option value="0" $sessiontluset[0]></option><option value="1" $sessiontluset[1]></option></select><br>
								$sessionkeepmsg
							</li>
						</ul>
					</fieldset>
				</div>
				<p>
					ׂĂ̐ݒ肪I牺L̃{^ĉBi^u̐؂ւ́AۑOɉ\\\łBj<br>
				</p>
				<p id="buttons">
					<input type="hidden" value="admin" name="mode">
					<input type="hidden" value="trychangesettings" name="work">
					<input type="submit" value="ݒۑ" id="sendinputs">
				</p>
				<p><small>ꕔ̐ݒ́ACGĨ\\\[XR[hɒڋLqdlɂȂĂ܂BCGĨ\\\[XeLXgGfB^ŕҏWĉB</small></p>
			</form>
		|;

		# CSSF
		my $css = '<style type="text/css">
			fieldset { margin: 1em; border: 1px solid #ccc; border-radius: 12px; background-color: white; }
			fieldset p { margin: 0.5em 0; }
			fieldset ul { list-style-type: none; margin:0; padding:0; }
			fieldset ul.list { list-style-type: disc; padding-left: 1.2em; }
			legend { font-weight: bold; text-shadow: -3px -3px 3px white, 3px -3px 3px white; }
			/* Zp[^tBOX */
			.withseparator { margin-top: 1em; padding-top: 1em; border-top: 1px dashed gray; }
			/* ͈ē */
			.inputguide { font-size: smaller; color: #808080; line-height: 1.2; }
			p.inputguide { margin-top: 1.5em; }
			/* tXyҏW */
			#freespace { margin: 1em; }
			#fsp { width: 90%; }
			.skinguide { margin: 1em 1.1em; font-size: smaller; color: #555; }
			/* ZbVێMSG */
			.inputinfo { font-size: 0.8em; line-height: 1.3; margin: 0.5em 0; padding: 0.25em; border-radius: 9px; background-color: #efc; }
			.inputinfo.alertinfo { background-color: #fdd; }

			/* ^u@\pWI{^͔\ */
			input.tabcheck { display: none; }
			/* ^u(ʑ{IԂ̑) */
			.tab {
				display: inline-block; padding: 0.67em 0.75em; border-width: 1px 1px 0px 1px; border-style: solid; border-color: black; border-radius: 0.75em 0.75em 0px 0px;
				background-color: #e0e0e0; color: black; font-weight: bold;
				display: none\9;	/* IE8΍:S\ */
			}
			.longtabname { display: none; }
			.tab:hover {
				background-color: #ccffcc; color: green; cursor: pointer;
			}

			/* `FbNĂ郉WI{^ׂ̗ɂ^ȗ(IԂ̃^u) */
			input:checked + .tab {
				position: relative; z-index: 10;
			}
			input:checked + #tab1 { background-color: #fdd; color: #d00; }
			input:checked + #tab2 { background-color: #efb; color: #680; }
			input:checked + #tab3 { background-color: #ddf; color: #00b; }
			input:checked + #tab4 { background-color: #fd9; color: #a70; }
			input:checked + #tab5 { background-color: #ffb; color: #880; }

			/* ^u̒g(ʑ{IԂ̑) */
			.tabcontent {
				display: none; border: 1px solid gray; margin-top: -1px; position: relative; z-index: 0;
				display: block\9;	/* IE8΍:S\ */
			}

			/* `FbNĂ郉WI{^ɑΉ^u̒g\ */
			#tabcheck1:checked ~ #tabcontent1,
			#tabcheck2:checked ~ #tabcontent2,
			#tabcheck3:checked ~ #tabcontent3,
			#tabcheck4:checked ~ #tabcontent4,
			#tabcheck5:checked ~ #tabcontent5 { display: block; }

			/* ^uwi */
			#tabcontent1 { background-color: #fdd; }
			#tabcontent2 { background-color: #efb; }
			#tabcontent3 { background-color: #ddf; }
			#tabcontent4 { background-color: #fd9; }
			#tabcontent5 { background-color: #ffb; }

			@media all and (min-width: 600px) {
				.tab li a { padding: 0.5em 0.5em 0.25em 0.5em; }
				.longtabname { display: inline; }
				fieldset ul.list { padding-left: 1.5em; }
			}
		</style>';

		&showadminpage('CHANGE SETTINGS','',$msg,'CA',$css);
	}
	elsif( $workkind eq 'trychangesettings' ) {
		# ݒt@C̍XV(TRY)@ɂ̓ftHg̒l̂ł͂ȂAf[^Ȃꍇ̒lB(:`FbN{bNXOFFƃf[^Ȃ)
		# HTMLtH[œKɍꂽڂf[^t@CɋL^Ă܂̂h߂ɁAł͑zς݂̍ږ`FbNāA炾ۑ֒ʂ悤ɂBŜ߁B

		my %trySetdat = (
			entryperpage		=> $cgi->param('entryperpage'		) || -1 ,
			entrypersitemappage	=> $cgi->param('entrypersitemappage') || -1 ,
			plinknext			=> $cgi->param('plinknext'			) || 'Next' ,
			plinkprev			=> $cgi->param('plinkprev'			) || 'Prev' ,
			plinkunit			=> $cgi->param('plinkunit'			) || 'Clips' ,
			plinkarrownext		=> $cgi->param('plinkarrownext'		) || '&raquo;' ,
			plinkarrowprev		=> $cgi->param('plinkarrowprev'		) || '&laquo;' ,
			plinkbacktohome		=> $cgi->param('plinkbacktohome'	) || 'S̕\ɖ߂' ,
			pagenumbracket1		=> $cgi->param('pagenumbracket1'	) || '' ,
			pagenumbracket2		=> $cgi->param('pagenumbracket2'	) || '' ,
			plinkseparator		=> $cgi->param('plinkseparator'		) || '<br>' ,
			                                                         	
			fixedclipnum		=> $cgi->param('fixedclipnum'		) || 0 ,
			                                                         	
			categories			=> $cgi->param('categories'			) || &errormsg("uJeSXgvɂ͍Œł1̃JeSKvłB") ,
			clipremoval			=> $cgi->param('clipremoval'		) || 0 ,
			allowtag			=> $cgi->param('allowtag'			) || '' ,
			allowand			=> $cgi->param('allowand'			) || '' ,
			hashtagsort			=> $cgi->param('hashtagsort'		) || 0 ,
			befhashts			=> $cgi->param('befhashts'			) || 0 ,		# ݒύXO̒l
			freespace			=> $cgi->param('freespace'			) || '' ,
			sessiontimenum		=> $cgi->param('sessiontimenum'		) || 1.5 ,	# 0͋ełȂl
			sessiontimeunit		=> $cgi->param('sessiontimeunit'	) || 0 ,
			                                                         	
			readmoreonoff1		=> $cgi->param('readmoreonoff1'		) || 0 ,
			readmoreonoff2		=> $cgi->param('readmoreonoff2'		) || 0 ,
			readmoreonoff3		=> $cgi->param('readmoreonoff3'		) || 0 ,
			readmoreonoff4		=> $cgi->param('readmoreonoff4'		) || 0 ,
			readmoreonoff5		=> $cgi->param('readmoreonoff5'		) || 0 ,
			readmoreonoff6		=> $cgi->param('readmoreonoff6'		) || 0 ,
			readmorelinklabel	=> $cgi->param('readmorelinklabel'	) || 'ǂ' ,
			readmorehtmltag		=> $cgi->param('readmorehtmltag'	) || 0 ,
			readmorecloseuse	=> $cgi->param('readmorecloseuse'	) || 0 ,
			readmorecloselabel	=> $cgi->param('readmorecloselabel'	) || '' ,
			textareasizenormal	=> $cgi->param('textareasizenormal'	) || 0 ,
			textareasizequick	=> $cgi->param('textareasizequick'	) || 0 ,
			hideclipurlinput	=> $cgi->param('hideclipurlinput'	) || '',	# p~(2.13.0)

			sitemappreheader	=> $cgi->param('sitemappreheader'	) || 'TCg}bv' ,
			showreverseheader	=> $cgi->param('showreverseheader'	) || 't' ,

			postformItemNo			=> $cgi->param('postformItemNo'			) || 0 ,
			postformItemTitle		=> $cgi->param('postformItemTitle'		) || 0 ,
			postformItemClipUrl		=> $cgi->param('postformItemClipUrl'	) || 0 ,
			postformItemCategory	=> $cgi->param('postformItemCategory'	) || 0 ,
			postformItemComment		=> $cgi->param('postformItemComment'	) || 0 ,
			postformItemDate		=> $cgi->param('postformItemDate'		) || 0 ,
			postformItemOptions		=> $cgi->param('postformItemOptions'	) || 0 ,
			postformTimeoutGuide	=> $cgi->param('postformTimeoutGuide'	) || 0 ,

			datelistShowYear	=> $cgi->param('datelistShowYear'	) || 0 ,
			befdatelistSY		=> $cgi->param('befdatelistSY'		) || 0 ,		# ݒύXO̒l
			urlautolink			=> $cgi->param('urlautolink'		) || 0
		);

		# sȒl`FbN
		if( $trySetdat{'entryperpage'} < 1 || !( $trySetdat{'entryperpage'} =~m/^\d+$/) ) { &errormsg("u1y[W̕\\\Nbvvɂ́A1ȏ̐w肷Kv܂B"); }
		if( $trySetdat{'entrypersitemappage'} < 1 || !( $trySetdat{'entrypersitemappage'} =~m/^\d+$/) ) { &errormsg("uTCg}bv1y[W̕\\\Nbvvɂ́A1ȏ̐w肷Kv܂B"); }
		if( $trySetdat{'fixedclipnum'} < 0 || !( $trySetdat{'fixedclipnum'} =~m/^\d+$/) ) { &errormsg("uɐ擪ɌŒ肵ĕ\\\Nbvvɂ́A0ȏ̐Ŕԍw肷Kv܂B"); }
		if( $trySetdat{'sessiontimenum'} < 0.5 && $trySetdat{'sessiontimeunit'} == 0 ) { $trySetdat{'sessiontimenum'} = 1.5; }	# ZbVĂꍇ͋C
		elsif( $trySetdat{'sessiontimenum'} < 0.0625 && $trySetdat{'sessiontimeunit'} == 1 ) { $trySetdat{'sessiontimenum'} = 1.5; $trySetdat{'sessiontimeunit'} = 0; }	# (Pʂuv̏ꍇ)

		# nbV^O̍ăJEgKvǂmFāAKvȂsBȉ̓f[^t@ĈŁAL̐ݒ̍XVOɎsKvBj
		my $recountres = '';
		if( $flagDemo{'RefuseToChangeSettings'} != 1 ) {
			if( $trySetdat{'befhashts'} != $trySetdat{'hashtagsort'} ) {
				# ̃nbV^O\[gԍƁAÕnbV^O\[gԍقȂĂ΁AăJEgB
				# ̐ݒl𔽉f
				$setdat{'hashtagsort'} = $trySetdat{'hashtagsort'};
				# nbV^O̍ăJEg𒼐ڎs
				&datahashcounter();
				$recountres .= '<p>nbV^ǑfڏύXꂽ߁AăJEg܂B</p>';
			}
			if( $trySetdat{'befdatelistSY'} ne $trySetdat{'datelistShowYear'} ) {
				# ̒lƑO̒lقȂĂ΁AăJEgB(̎_ł1̑checkedĂ)
				# ̐ݒl𔽉f
				$setdat{'datelistShowYear'} = $trySetdat{'datelistShowYear'};
				&datadatecounter();
				$recountres .= '<p>tXg̐ݒ肪ύXꂽ߁AăJEg܂B</p>';
			}
		}

		# JeSXgJ}؂ɕύXiToDo:JeSɃJ}܂܂ꍇ̑ΏKvj
		$trySetdat{'categories'} =~ s/\r\n/,/g;

		# t[Xy[X̉sϊif[^1sɂKvj
		$trySetdat{'freespace'} =~ s/\r\n/<br>/g;

		if( $flagDebug{'ShowDebugStrings'} == 1 ) {
			# Azz%trySetdat̒gׂďo(fobOp)
			while( my ($key, $value) = each(%trySetdat) ) {
				print STDERR "[TRY]$key=$value\n";
			}
		}

		# ݒt@CXV
		my $msg;
		if( $flagDemo{'RefuseToChangeSettings'} != 1 ) {

			# ݒt@Cɏނ߂̏
			my @trywrites;
			# Azz%trySetdat̒gׂĕۑp`ɐ`Ăzɓ
			while( my ($key, $value) = each(%trySetdat) ) {
				push( @trywrites, "$key=$value" );
			}

			# ۑ֓n
			&savesettings( @trywrites );

			# ʕ񍐃bZ[Wp
			$msg = qq|
				<h2>ݒύX</h2>
				<p>ݒύX܂B</p>
			|;
			$msg .= $recountres;

		}
		else {
			# DEMOFݒύX
			$msg = qq|
				<h2>DEMO</h2>
				<p style="color:red;">f[hœ삵Ă邽߁Aݒ̕ύX͂ł܂łB</p>
			|;
		}

		&showadminpage('COMPLETE','',$msg,'CA');
	}
	elsif( $workkind eq 'changepass' ) {
		# pX[h̕ύX(FORM)
		my $msg = qq|
			<p>pX[hύX܂B</p>
			<form action="./hb.cgi" method="post">
				pX[h: <input type="password" value="" name="nowpass"><br>
				VpX[h: <input type="password" value="" name="newpass1"><br>
				VpX[h(ē): <input type="password" value="" name="newpass2"><br>
				<input type="hidden" value="admin" name="mode">
				<input type="hidden" value="trychangepasswd" name="work">
				<input type="submit" value="pX[hݒ"><br>
			</form>
			<p>߂ăpX[h쐬ꍇ́AupX[hv͋󗓂̂܂܂ō\\\܂B</p>
		|;
		&showadminpage('CHANGE PASSWORD','',$msg,'CA');
	}
	elsif( $workkind eq 'trychangepasswd' ) {
		# pX[h̕ύX(TRY)
		my $nowpass  = $cgi->param('nowpass')  || "";
		my $newpass1 = $cgi->param('newpass1') || "";
		my $newpass2 = $cgi->param('newpass2') || "";
		
		# pX[ḧvmF
		if( &checkpass($nowpass) < 0 ) {
			# sv
			my $msg = '<h2>pX[hύXs</h2><p>pX[hĩ݂pX[hjႢ܂B<br>pX[h͕ύXł܂łB</p>';
			&showadminpage('Authentication','',$msg,'RA');
			exit;
		}
		
		# VpX[h2͈vmF
		if( $newpass1 ne $newpass2 ) {
			# sv
			my $msg = '<h2>pX[hύXs</h2><p>͂ꂽuVpX[hvƁuVpX[h(ē)v̓eقȂ܂B2̗ɂ́ApX[h͂ĉB</p>';
			&showadminpage('Authentication','',$msg,'RA');
			exit;
		}
		# pX[h̕ύXipX[hύXƓɁAׂẴZbVIDjBj
		if( $flagDemo{'RefuseToChangePassword'} != 1 ) {
			my $recstring = crypt($newpass1,$cryptkey);
			open PWIN, ">$passfile";
			print PWIN $recstring . "\n";
			close PWIN;
		}
		else {
			# DEMO[hFpX[h̕ύX
			my $msg = '<h2>DEMO</h2><p style="color:red;">f[hœ삵Ă邽߁ApX[h̕ύX͂ł܂łB</p><p style="font-size:smaller;">f[hɂ́ACGI\[X̃tOKv܂B</p>';
			&showadminpage('Password Not Changed','',$msg,'CA');
			exit;
		}

		my $msg = "<h2>pX[hύX</h2><p>pX[hύX܂BVpX[hgāAēxOCĉB</p>";
		&showadminpage('Password Changed','',$msg,'CA');
	}
	elsif( $workkind eq 'recount' ) {
		# ăJEg
		my $msg = '<p>SNbvăJEgAJEgl̃LbVf[^XV܂B(JeSYANʊYAnbV^OY)</p>';
		my $cc = 0;
		$msg .= '<h2>JeSWv:</h2><ul>';
		foreach my $onecat (&categorycounter()) {
			$msg .= "<li>JeSNo.$cc : $onecat</li>";
			$cc++;
		}
		$msg .= '</ul><h2>NWv:</h2>';
		&datadatecounter();
		$msg .= $setdat{'datelisthtml'};
		$msg .= '<h2>nbV^OWv:</h2>';
		$msg .= &datahashcounter();
		&showadminpage('RECOUNTED','',$msg,'CA');
	}
	elsif( $workkind eq 'backup' ) {
		# f[^̃obNAbvj[
		my $msg = qq|
			<p>SNbvf[^obNAbv܂B</p>
			<p>
				L̃N({^)NbNƁASNbvf[^܂XMLt@C_E[hł܂B
				ANbvf[^Ă܂ꍇɂ́AobNAbvt@CuCGIŐݒ肵Ăf[^t@CvɃl[ăAbv[h΁Ȁ݂Ԃɖ߂܂B
				ł邾pɂɃobNAbvĂƂߒv܂B
			</p>
			<ul class="systemmenu">
				<li><a href="?mode=getbackupfile"><span class="jp">obNAbvf[^_E[h</span><span class="en">Download Backup file</span></a></li>
			</ul>
			<p class="note">
				L̃{^Ń_E[hɂȂȂꍇ(uEUXML\\\Ă܂ꍇ)́AENbNāuOtăNۑvȂǂ̃j[gĉB
			</p>
		|;
		&showadminpage('BACKUP','',$msg,'CA');
	}
	elsif( $workkind eq 'skinlist' ) {
		# ʃXL̓Kpj[

		# fBNg̃t@Cꗗ𓾂
		opendir( DIRECTORY, './' ) or &errormsg("fBNgJ܂łB");
		my @filelist = readdir( DIRECTORY );
		closedir( DIRECTORY );
		splice( @filelist, 0, 2 );

		# `FbNăXgAbv
		my $msg = '';
		my $skinlinks = '<ul class="skindirectories">';
		my $skincount = 0;
		foreach my $onefile (@filelist) {
			if( -d $onefile ) {
				# fBNgAXLt@C݂̑mF
				my $tryskin1 = $onefile . '/' . $skinfilecover;
				my $tryskin2 = $onefile . '/' . $skinfileclip;
				if(( -f $tryskin1 ) && ( -f $tryskin2 )) {
					# XLt@C2Ƃ݂烊XgAbv
					$skinlinks .= qq|<li><a href="?skin=$onefile">$onefile</a></li>|;
					# JEg
					$skincount++;
				}
			}
		}
		$skinlinks .= '</ul>';

		if( $skincount > 0 ) {
			# Kp\ȃXL1ȏ゠
			$msg = q|<p>L̕ʃXL܂BNNbNƁA<strong class="important">ꎞI</strong>̃XLKpԂ邱Ƃł܂B<br></p>|;
			$msg .= $skinlinks;
			$msg .= q|Ǘʂɖ߂ƁAʃXL̓Kpʂ͎܂B<br>ȂȊỎ{҂̉ʂɂ͈؉e܂B(Ap[^tURLɒڃANZX΁ANłXL̓Kpʂ{\łB)<br>XL{ԓKpɂ́AXL\t@CQuCGIƓfBNgvɃRs[(orړ)ĉB|;
		}
		else {
			# Kp\ȃXLȂ
			$msg .= q|<p>Kp\ȕʃXLt@C͌܂łB</p>|;
		}
		$msg .= q|<p class="note">̉ʂɂ́ACGIݒuĂfBNgɂATufBNgɊi[ꂽʃXLt@Cꗗ\܂B1XLƂ1TufBNgăAbv[hƁAɈꗗŌ܂B(TufBNgȍ~̊Kw͑܂BA蓮Ńp[^Lq΁ATufBNgȍ~̊KwɂXLKp\łB)<br>܂łꎞIɎKp邽߂̋@\Ȃ̂ŁAXLHTML̋Lq@ɂẮACSSKpłȂAN@\Ȃꍇ܂B</p>|;
		&showadminpage('ANOTHER SKIN LIST','',$msg,'DA');
	}
#	elsif( $workkind eq 'uconst' ) {
#		# Under Construction
#	}
	else {
		# sWorkp[^l
		&errormsg("p[^̒lsłB");
	}
}
elsif( $showmode eq 'getbackupfile' ) {
	# obNAbvf[^̃_E[h(octet-stream)

	# ܂͓ǂݎp[hŔF؂mF
	if( &checkpermission(1) == 0 ) {
		# OCĂȂ
		&errormsg("̑͊ǗʂɃOCĂԂɂsł܂B");
	}

	my $dlFileName;

	my ($mday,$month,$year) = (localtime(time))[3,4,5];
	$year  = $year + 1900;
	$month = &addzero($month + 1);
	$mday  = &addzero($mday );

	$dlFileName = "hb-backup$year$month$mday.xml";

	# f[^t@CJ
	open (DF, $bmsdata)  or &errormsg("f[^t@CJ܂łB");

	# wb_octet-streamo
	print <<"OSHEAD";
Content-type: application/octet-stream
Content-Disposition: attachment; filename=$dlFileName

OSHEAD

	# f[^t@C̒go
	binmode DF;
	binmode STDOUT;
	while (my $DFdata = <DF>) {
		print STDOUT $DFdata;
	}

	# t@C
	close DF;
}
elsif( $showmode eq 'passcheck' ) {

	# PASSCHECK MODE
	my $defaultnextpage = "?mode=admin";	# ftHgł̎̍s

	# f[^MemF
	my $trypass = $cgi->param('trystring') || "";
	my $nexturl = $cgi->param('nexturl') || "$defaultnextpage";

	# sȈړ̃`FbN
	if( $nexturl !~ m/^\?/  ) {
		# nexturlu?vLŎn܂ĂȂ΁AړC
		$nexturl = $defaultnextpage;
	}

	# pX[h`FbN
	if( &checkpass($trypass) >= 0 ) {
		# vFZbVNbL[̔s

		# ZbVID̐
		my $sessionid = &makesessionid();
		# ZbVCookie̔s
		print &makesessioncookie($sessionid);

		# {̃ANZXɃ_CNg
		print "Location: hb.cgi$nexturl\n\n\n";
	}
	else {
		# svFē̗͂v
		&passfront($nexturl,1);
	}
}
else {
	# ̃p[^
	&errormsg("[hp[^̒lsłB");
}

exit;
# ŏIΖ̃fobOpR[h͎sȂB

# ------------------------ #
# ZbVID̐EL^ #	L^`F SESSION=L,ZbVID[s]
# ------------------------ #
sub makesessionid
{
	# pX[hEZbVIDL^t@C̓ǂݍ
	open( PWIN, $passfile ) or &errormsg("pX[hEZbVIDL^t@CJ܂łB");
	my @alldata = <PWIN>;
	close PWIN;

	# z擪ÍpX[hꍇ͔z񂩂菜Ă
	my $savepw = "";
	if( $alldata[0] =~ m/^$cryptkey/ ) {
		$savepw = shift @alldata;
	}

	# ZbVID
	my $pw;
	if( $alldata[0] =~ m/^$cryptkey/ ) {
		$pw = substr( $alldata[0], 2, 3 );	# ÍꂽpX[h3擾(ÍL[)
	}
	else {
		$pw = substr( time, -3, 3 );		# ̖3擾
	}

	# ZbVID̐
	srand();
	my $baseid = $pw . rand(99999);			# Œ8𒴂镶񂪂ł
	my $sessionid = crypt($baseid ,'ck');	# KȃL[ňÍiZbVIDƂj

	# ZbṼ^CAEg̐
	my $timeouttime = time + $sessiontimeout;

	# ɂȂZbVID̍폜
	my $cutpoint = 0;
	foreach my $onesid ( @alldata ) {
		if( $onesid =~ m/^SESSION=(\d+),.+/ ) {
			# ZbVID̗L𓾂Ēׂ
			if( $1 < time ) {
				# LĂ΍폜Ώ
				$cutpoint--;
				last;
			}
		}
		$cutpoint++;
	}
	$#alldata = $cutpoint;		# LĂ鍀ڈȍ~S폜iID͎̍~ɕł̂Oj

	# L^(z̐擪ɒǉ)
	unshift( @alldata, "SESSION=$timeouttime,$sessionid\n" );

	# ŏɃpX[hz񂩂菜ꍇ͏߂
	if( length($savepw) > 0 ) {
		unshift( @alldata, $savepw );
	}

	# o
	open( PWOUT, ">$passfile" ) or &errormsg("pX[hEZbVIDL^t@CJ܂ł(o͂ł܂ł)B̏ȂƃOCł܂B");
	print PWOUT @alldata;
	close PWOUT;

	return $sessionid;
}

# ------------------ #	łCookieXV̂ŁÅ֐Oɏo͗pwb_oȂ悤ӁBiZbVێݒ̏ꍇ̂݁j
# F؁F`FbN #@@idebug_ShowDebugStrings1̂Ƃ́ACookieXVłȂBAXVłȂĂCookie̗L܂ł͖ȂłnYBj
# ------------------ #@@K{ł͂ȂreadonlyflagF l1ȂF؏̍XVȂB
sub checkpermission
{
	my $readonlyflag = shift @_ || 0;

	return 1 if( $flagDebug{'NoAuthentication'} == 1 );	# for DEBUG

	# CookieɊi[ꂽZbVID̗LmF(ԒlFL=1/=0)
	my $sessionid = $cgi->cookie(-name=>'fncsid');

	if( $flagDebug{'ShowDebugStrings'} == 1 ) {
		print STDERR "SESSION ID is $sessionid.\n";
	}

	# pX[hEZbVIDL^t@C̓ǂݍ݂ƈvmF
	my $res = 0;
	open PWIN, $passfile;
	my @alldata = <PWIN>;
	close PWIN;

	foreach my $onesid ( @alldata ) {
		# SZbVIDƔr
		if( $onesid =~ m/^SESSION=(\d+),$sessionid$/ ) {
			# vZbVIDΗLmF
			if( $1 >= time ) {
				# LłOK
				if( $flagDebug{'ShowDebugStrings'} == 1 ) {	# for DEBUG String
					my $limit = $1;
					my $nowtime = time;
					my $leave = $nowtime - $limit;
					print STDERR "[Limit] $limit , [NOW] $nowtime , (Leave) $leave.\n";
				}
				# LXV
				my $nowlimit = $sessiontimeout + time;
				$onesid = "SESSION=$nowlimit,$sessionid\n";
				# OK SIGN
				$res = 1;
			}
		}
	}

	# F؂ɒʉ߂ŁAǂݍݐpłȂ΁AF؏XV
	if(( $res == 1 ) && ( $readonlyflag != 1 )) {
		# ZbVL̍XV
		open PWOUT, ">$passfile";
		print PWOUT @alldata;
		close PWOUT;

		# ZbVi[Cookie̍XV
		print &makesessioncookie($sessionid);
	}

	return $res;
}

# ---------------------------- #
# F؁FZbVCookie̐ #	FZbVID	Cookie𐶐邾ŏo͂͂ȂB
# ---------------------------- #
sub makesessioncookie
{
	my $sessionid = shift @_;

	my $cookie;
	if( $keepsession == 1 ) {
		# uEUIĂZbVێꍇ
		# cookie̗L쐬iZbVL{1j100Ȃu+100dvƂɂȂ
		my $expiredate = "+" . (( $sessiontimeout / (60 * 60 * 24) ) + 1 ) . "d";
		# ZbV̗L{1w
		$cookie = $cgi->cookie(-name =>'fncsid', -value => $sessionid , -expires => $expiredate );
	}
	else {
		# ZbV̓uEUI܂
		$cookie = $cgi->cookie(-name =>'fncsid', -value => $sessionid );
	}
	return "Set-Cookie: $cookie\n";
}

# -------------------- #
# F؁FOAEg #
# -------------------- #
sub logout
{
	# CookieɊi[ꂽZbVID𓾂
	my $sessionid = $cgi->cookie(-name=>'fncsid');

	# pX[hEZbVIDL^t@C̓ǂݍ݂ƈvmF
	my $res = 0;
	open PWIN, $passfile;
	my @alldata = <PWIN>;
	close PWIN;

	foreach my $onesid ( @alldata ) {
		# SZbVIDƔr
		if( $onesid =~ m/^SESSION=(\d+),$sessionid$/ ) {
			# vZbVIDΗL𖳌ɂ
			$onesid = "SESSION=0,$sessionid\n";
			$res = 1;
		}
	}

	if( $res == 1 ) {
		# ZbVL̍XV
		open PWOUT, ">$passfile";
		print PWOUT @alldata;
		close PWOUT;
	}

	# Cookie폜 ZbV𖳌ɂȏACookie̍폜͕K{ł͂ȂA܂ՂIɏĂB(ZbVێȂݒȂuEȔIƓCookiej邪A炩̌ŃZbVIDL^t@CIDjłȂƂ̂߂Cookie폜ĂƈSB)
	my $delcookie = $cgi->cookie(-name =>'fncsid', -value => $sessionid , -expires => "-1d" );
	print "Set-Cookie: $delcookie\n";

	return $res;	# T[oŁFOAEgF1 ^ OAEgsF0@iCookieĵŁAǂɂĂOAEg͂łj
}

# ------------------ #
# F؁Fy[W #	nexturl̒g͕Ku?vLŎn܂ĂȂ΂ȂȂB(ȊOpasscheck̃_CNgɒedl)
# ------------------ #
sub passfront
{
	my ($nexturl,$tryagain) = @_;

	# 상F ~KvȃtH[ƒlnbVŎ󂯎AׂĂWJ
	#            KvGET URLϐɎ
	my $errmsg = "";
	if( $tryagain > 0 ) {
		$errmsg = '<p style="color:red;">pX[hႢ܂Bēx͂ĉB</p>';
	}
	else {
		$errmsg = '<p>Ǘɂ̓pX[hKvłB</p>';
	}

	my $msg;

	# fsp̃bZ[W
	my $DemoMsg;
	if( $flagDemo{'LoginMessage'} > 0 ) {
		$DemoMsg = '<p style="font-size:90%; color:#cc0000; font-weight:bold;"><span style="background-color:#cc0000; color:white; padding:0.3em;">sTvt</span> pX[h <code style="font-size:100%;">guest</code> ŃOCł܂B</p>';
	}

	# URLƂĕsȕ񂪎w肳Ăꍇ̑Ώ
	$nexturl = &forsafety($nexturl);

	if( &checkpass('') != 1 ) {
		# pX[hɐݒ肳Ă΃OCtH[\

		# ----------------------------------
		# ZbVL̈ē\쐬
		my $loginkeeporunkeep = '';
		my $timeoutlim = &sectotimestring( $sessiontimeout );
		if( $keepsession == 1 ) {
			# ZbVێݒȂLē
			$loginkeeporunkeep = qq|uEUIĂAZbVL܂ł̓OCԂێݒɂȂĂ܂BZbVĹAŌɊǗʂɃANZX_$timeoutlimɐݒ肳Ă܂B(CGI̐ݒŎRɕύXł܂B)|;
		}
		else {
			# ZbVێȂݒȂ
			$loginkeeporunkeep = qq|uEUIƎOAEgݒɂȂĂ܂BȂAuEUIȂĂAŌɊǗʂɃANZX_$timeoutlimo߂ƁAOAEg܂B(̎ԂCGI̐ݒŎRɕύXł܂B)|;
		}

		# --------------
		# \HTML𐶐
		$msg = qq|
			$errmsg
			<form action="./hb.cgi" method="post">
				Enter Password: <input type="password" value="" name="trystring">
				<input type="hidden" value="passcheck" name="mode">
				<input type="hidden" value="$nexturl" name="nexturl">
				<input type="submit" value="OC">
			</form>
			$MsgForLoginScreen $DemoMsg
			<div class="loginguide">
				<p class="guidetitle">ypX[hYꂽꍇz</p>
				<p class="guidemsg">T[oɂupX[hEZbVIDi[t@CvɂăAbv[hĉBƁAOCł悤ɂȂ܂B̌AǗj[pX[hĐݒł܂BipX[h͈ÍԂŕۑĂ̂ŁAt@C̒g`ĂpX[h͕܂Bj</p>
				<p class="guidetitle">yOCłȂꍇz</p>
				<p class="guidemsg">OC邽߂ɂ́ACookie󂯓Kv܂BuEU̐ݒŁACookieۂĂȂmFĂ݂ĉB܂AupX[hEZbVIDi[t@Cvւ݂̏sƁAF؏ۑłȂ߃OCł܂Bt@Cւ̏݌ݒ肳Ă邩AFTP\\\tgȂǂŊmFĂ݂ĉB</p>
				<p class="guidetitle">sOCɃuEUIꍇ̓t</p>
				<p class="guidemsg">$loginkeeporunkeep</p>
			</div>
		|;
	}
	else {
		# pX[hݒ肳ĂȂΖOCtH[\
		$msg = qq|
			<p>悤AFumy News Clipper2ցI</p><p>݁AǗppX[hݒ肳ĂȂ߁ANłOCłԂɂȂĂ܂B<br>L̃{^NbNăOCĉB</p>
			<form action="./hb.cgi" method="post">
				<input type="hidden" value="" name="trystring">
				<input type="hidden" value="passcheck" name="mode">
				<input type="hidden" value="$nexturl" name="nexturl">
				<input type="submit" value="OC"><br>
			</form>
			<p><strong class="important">OCAŏɃpX[h̐ݒKsĉB</strong></p>
			<div class="loginguide">
				<p class="guidetitle">yOCłȂꍇz</p>
				<p class="guidemsg">OC邽߂ɂ́ACookie󂯓Kv܂BuEU̐ݒŁACookieۂĂȂmFĂ݂ĉB܂AupX[hEZbVIDi[t@Cvւ݂̏sƁAF؏ۑłȂ߃OCł܂Bt@Cւ̏݌ݒ肳Ă邩AFTP\\\tgȂǂŊmFĂ݂ĉB</p>
			</div>
		|;
	}

	# CSSF
	my $css = '<style type="text/css">
		.loginguide { margin-top: 2em; padding-top: 0.75em; border-top: 1px dashed gray; font-size:smaller; color:#555555; }
		.loginguide .guidetitle { margin: 1em 0 0.25em 0; font-weight: bold; background-color: #eeeeee; border-left: 1em solid #bbbbbb; }
		.loginguide .guidemsg { margin: 0; }
	</style>';

	&showadminpage('Authentication','',$msg,'C',$css);
}

# ------------------------ #
# F؁FpX[h`FbN #	0:v / 1:pX[hȂ / -1:sv
# ------------------------ #
sub checkpass 
{
	my $trypass = shift @_;

	# pX[hǂݍ
	open PWIN, $passfile;
	my $cpass = <PWIN>;		# 1sڂ̂ݎ擾
	close PWIN;
	chomp($cpass);	# sR[h(K܂܂)폜

	# t@CɃpX[h񂪑݂Ȃꍇ͏ɋ
	if( $cpass eq "" || $cpass =~ m/^SESSION=/ ) {
		return 1;
	}

	# [Ü͕Í
	my $tcpass = crypt($trypass,$cryptkey);

	# pX[hv`FbN
	if( $cpass eq $tcpass ) {
		return 0;
	}
	return -1;
}

# ------------------------ #
# f[^t@CFǂݍ #
# ------------------------ #
sub loadsettings
{
	open SETTINGS, $setfile;
	foreach my $setline (<SETTINGS>) {
		if( $setline =~ m/^(.+?)=(.*)$/ ) { $setdat{$1} = $2; }	# L^Ă鍀ږ(=̍)ɊYAzz(%setdat)ɁAel(=̉E)B
	}
	close SETTINGS;

	# JeS̓WJ (ɃGXP[v)
	@categories = split(/,/, &forsafety($setdat{'categories'}) );
}

# ------------------------ #	ݓeꗗzŎ󂯎A󂯎ӏXVB󂯎Ȃڂ͌ێB
# f[^t@CF #	^z̒ǵÂ܂܃f[^t@Cɏ݂ł`ɂł邱ƁB
# ------------------------ #	@l̐́Ał͊mFȂ̂ŁAOɍς܂ĂB
sub savesettings
{
	# o[WԍER[h
	$setdat{'[version]'} = $versionnum;
	$setdat{'{charset}'} = $charcode;

	# ݒێĂAzz%setdat̓eA̔zɎw肳ꂽeɏ
	my $renewcount = 0;
	foreach my $tryoneset (@_) {
		if( $tryoneset =~ m/^(.+?)=(.*)$/ ) { $setdat{$1} = $2;	$renewcount++; }	# Ɏw肳ꂽ[L[l]̃ZbgAAzz%setdat֏㏑āA㏑JEgB
	}

	# ݒt@Cɏ݁iޕKvꍇ̂݁j
	if( $renewcount > 0 ) {
		open SETOUT, ">$setfile";

		# Azz%setdat̒gL[Ń\[gŏo͌`ɐ`ďo
		for my $name (sort keys %setdat) {
			print SETOUT "$name=$setdat{$name}\n";
		}

		close SETOUT;
	}

	return $renewcount;
}

# ---------------------- #
# etH[HTML̍쐬 #	F1`6FҏWf[^iOFYڂɉf[^Ȃꍇ͋󕶎''ɂȂĂj
# ---------------------- #@@@@7FuQUICKvNCbNetH[
sub makepostform
{
	my ( $id, $datetime, $title, $newsurl, $category, $comment, $formmode ) = @_;

	# ҏWΏIDtH[̍쐬(VKҏW)
	my $idForm;
	my $moveCheck = "";
	if( $id ne '' ) {
		# ҏW̏ꍇ
		$idForm = qq|No.$id [<input type="radio" value="$id" name="id" id="ide" checked><label for="ide">Edit</label> / <input type="radio" value="" name="id" id="idn"><label for="idn">New</label>]|;
		# ҏW̏ꍇɕҏWNbv擪Ɉړ邩ǂ
		if( $setdat{'clipremoval'} == 0 ) {
			# 擪ɂ͈ړȂ(l1𑗂Ȃ)
			$moveCheck = qq|<span class="checkbox"><label><input type="checkbox" name="movetohead" value="1">Nbv擪Ɉړ</label></span>|;
		}
		else {
			# 擪Ɉړ(l1𑗂)
			$moveCheck = qq|<span class="checkbox"><label><input type="checkbox" name="movetohead" value="1" checked>Nbv擪Ɉړ</label></span>|;
		}
	}
	else {
		# VK̏ꍇ
		$idForm = qq|NEW <input type="hidden" value="" name="id">|;
		$datetime = &getdatetimestring();	# ݓ
	}

	# for DEMO
	my $tagdisabled = '';
	my $demo_del1 = '';
	my $demo_del2 = '';
	my $msgeditguide = '';
	if( $flagDemo{'NotAllowHtml'} != 0 ) {
		$tagdisabled = ' disabled';
		$demo_del1 = '<del onclick="alert(\'f[hŎŝ߁AHTML^O͎g܂B\');">';
		$demo_del2 = '</del>';
		$setdat{'allowtag'} = '';
		$msgeditguide = '<p class="demonotice"><span>f[hŎŝ߁AHTML^O͎g܂B</span>iۂɎgpۂ͐ݒ莟HTML^Ogp\łBj</p>';
	}

	# cccccccccccc
	# epHTMLtH[̐
	# cccccccccccc
	my $postformhtml = qq|\n<!-- etH[ -->\n<form action="./hb.cgi" method="post" class="clipedit">\n<table class="edittable">\n|;
	my $postformHiddens = '';

	# ----------------------------------------
	# STEP.1uEdit No.v\邩ǂ (QUICKeł͏ɔ\)
	if( $formmode ne 'QUICK' && $setdat{'postformItemNo'} != 0 ) {
		# Edit No\
		$postformhtml .= qq|<tr><th>Edit No.</th><td>$idForm $moveCheck</td></tr>\n|;
	}
	else {
		if( $id ne '' ) {
			# Edit No\ȂݒłANbv̕ҏW̏ꍇ͔ԍn
			$postformHiddens .= qq|<input type="hidden" value="$id" name="id">|;
		}
	}

	# ----------------------------------------
	# STEP.2u^Cgv\邩ǂ
	if( $setdat{'postformItemTitle'} != 0 ) {
		# ^Cg\
		$postformhtml .= qq|<tr><th>^Cg:</th><td><input id="editboxtitle" type="text" value="$title" name="title" size="45"></td></tr>\n|;
	}
	else {
		# ^Cg͕\Ȃl͈ێ
		$postformHiddens .= qq|<input type="hidden" value="$title" name="title">|;
	}

	# ----------------------------------------
	# STEP.3uCLIP URLv\邩ǂ ($setdat{'hideclipurlinput'}͋łƂ̌݊ێ̂)
	if( $setdat{'hideclipurlinput'} ne 'checked' && $setdat{'postformItemClipUrl'} != 0 ) {
		# CLIP URL\
		$postformhtml .= qq|<tr><th>CLIP URL:</th><td><input id="editboxurl" type="text" value="$newsurl" name="newsurl" size="45"></td></tr>\n|;
	}
	else {
		# CLIP URL͕\Ȃl͈ێ
		$postformHiddens .= qq|<input type="hidden" value="$newsurl" name="newsurl">|;
	}

	# ----------------------------------------
	# STEP.4uJeSv\邩ǂ
	if( $setdat{'postformItemCategory'} != 0 ) {
		# JeS\
		# JeSv_Ej[̏
		my @cathtmls;
		push(@cathtmls,'<select name="category">');
		my $catcount=0;
		foreach my $onecat (@categories) {
			my $defcat="";
			if( $catcount == $category ) {
				$defcat = ' selected';
			}
			push(@cathtmls,"<option value=\"$catcount\"$defcat>$onecat</option>");
			$catcount++;
		}
		push(@cathtmls,'</select>');
		# \
		$postformhtml .= qq|<tr><th>JeS:</th><td>| . join("",@cathtmls) . qq|</td></tr>\n|;
	}
	else {
		# JeS͕\Ȃl͈ێ
		$postformHiddens .= qq|<input type="hidden" value="$category" name="category">|;
	}

	# ----------------------------------------
	# STEP.5uRgv\邩ǂ
	if( $setdat{'postformItemComment'} != 0 ) {
		# Rg\
		# Rg͗̒ݒ肷style
		my $textareasizestyle = '';
		if( $formmode eq 'QUICK' ) { $textareasizestyle = 'style="height:' . $setdat{'textareasizequick'} . 'em;"'; }
		else { $textareasizestyle = 'style="height:' . $setdat{'textareasizenormal'} . 'em;"'; }
		$postformhtml .= qq|<tr><th>Rg:<br><span id="commentTextCountArea"></span></th><td><textarea id="editboxcomment" name="comment" rows="7" cols="45" $textareasizestyle>$comment</textarea><script type="text/javascript">document.getElementById('editboxcomment').onkeyup = function(){ document.getElementById("commentTextCountArea").innerHTML = "(" + this.value.length + "<small></small>)"; }</script><br>$msgeditguide</td></tr>\n|;
	}
	else {
		# Rg͕\Ȃl͈ێ
		$postformHiddens .= qq|<input type="hidden" value="$comment" name="comment">|;
	}

	# ----------------------------------------
	# STEP.6utv\邩ǂ
	if( $setdat{'postformItemDate'} != 0 ) {
		# t\
		$postformhtml .= qq|<tr><th>t:</th><td><input id="editboxdatetime" type="text" value="$datetime" name="datetime" size="25"><small>i󗓂ɂƓȅuԂ̓L^j</small></td></tr>\n|;
	}
	else {
		# t\Ȃil̑MȂFeuԂ̓L^j
		$postformHiddens .= qq|<input type="hidden" value="" name="datetime">|;
	}

	# ----------------------
	# e{^(K{)
	$postformhtml .= qq|<tr><td colspan="2" class="postbuttons">\n|;

	# ----------------------------------------
	# STEP.7IvVڂ\邩ǂ
	if( $setdat{'postformItemOptions'} != 0 ) {
		# IvVڂ\
		$postformhtml .= qq|
			<div class="suboptions">
				<small>^CgƃRg...</small>
				$demo_del1<input type="checkbox" value="1" name="allowtag" id="allowtag" $setdat{'allowtag'}$tagdisabled><label for="allowtag">HTML^O</label>$demo_del2
				<input type="checkbox" value="1" name="allowand" id="allowand" $setdat{'allowand'}><label for="allowand">̎QƂ̎gp</label>
			</div>
		|;
	}
	else {
		# IvVڂ\A^O̎QƂ֎~
		# $postformHiddens .= qq||;
	}

	# ----------------------
	# e{^Ȃ(K{)
	$postformhtml .= qq|<input type="hidden" value="write" name="mode">$inputtagforapplyskin \n<input type="submit" value="L̓e𓊍e" id="sendinputs"><br></td></tr>\n</table>\n|;

	# --------------------------------------------
	# STEP.8^CAEgē\邩ǂ (QUICKłȂΏɕ\)
	if( $formmode ne 'QUICK' || $setdat{'postformTimeoutGuide'} != 0 ) {
		# \
		$postformhtml .= '<p class="timeoutmsg">' . &sectotimestring( $sessiontimeout ) . 'ȓɓeȂƃ^CAEgĂ܂܂̂ŁAӉB</p>';
	}

	# o͗p̕
	$postformhtml .= qq|\n$postformHiddens\n</form>\n<!-- etH[(܂) -->\n|;

	# HTMLԂ
	return $postformhtml;
}

# ---------------------------- #
# XVēN{bNX̐ #	1Ffڗvf( T:Nt^Cg, D:tt, C:JeS )Ə
# ---------------------------- #	2F
sub gettopclips
{
	my ( $disporder, $dispnum ) = @_;

	my $reshtml = '<ol class="topclipslink">';

	# ɐɂȂ悤f[^Rs[
	my @copydata;
	if( $showorder eq 'reverse' ) {
		# tȂf[^̔zt]ăRs[
		@copydata = reverse(@xmldata);
	}
	else {
		# Ȃ炻̂܂܃Rs[
		@copydata = @xmldata;
	}

	if( $dispnum < 1 ) { $dispnum = 1; }	# ͍Œ1
	elsif( $dispnum > ($#xmldata+1) ) { $dispnum = $#xmldata+1; }	# ͍őŃf[^

	# f[^Ŝ𑖍
	my $counter=0;
	foreach my $oneclip (@copydata) {

		# 
		my $id		= &forsafety( &fumyxmlpackage::getcontent($oneclip,'id') );
		my $datetime= &forsafety( &fumyxmlpackage::getcontent($oneclip,'date') );
		my $title	= &forsafety( &fumyxmlpackage::getcontent($oneclip,'title') );
		#my $newsurl	= &forsafety( &fumyxmlpackage::getcontent($oneclip,'newsurl') );
		my $category= &forsafety( &fumyxmlpackage::getcontent($oneclip,'category') );
		#my $comment	= &fumyxmlpackage::getcontent($oneclip,'comment');

		if( $id == $setdat{'fixedclipnum'} ) {
			# ŒNbvΏۂɂ΂
			next;
		}

		# w萔ɒBǂ
		if( $counter < $dispnum ) {
			# ܂ȂFfڗvf
			my $onerec = '<li class="onerec">';
			foreach my $ch (split //, $disporder) {
				# w蕶ɏ]ėvfǉ
				if(    $ch eq 'D' ) { $onerec .= qq|<span class="postdate">$datetime</span>|; }						# D:tt
				elsif( $ch eq 'T' ) { $onerec .= qq|<a href="?clip=$id">$title</a>|; }								# T:^Cg
				elsif( $ch eq 'C' ) { $onerec .= qq|<span class="postcategory">$categories[$category]</span>|; }	# C:JeS
			}
			$onerec .= '</li>';
			$reshtml .= $onerec;

			$counter++;
		}
		else {
			# w萔ɒBI
			last;
		}
	}

	return ($reshtml . '</ol>');
}

# ------------------------------------------ #
# w̃Nbvf[^Q̐擪ɂ} #
# ------------------------------------------ #
sub put1cliptohead
{
	my $targetnum = shift @_;

	# 0牽Ȃ
	if( $targetnum == 0 ) { return 1; }

	# f[^Ŝ𑖍
	my $counter=0;
	foreach my $oneclip (@xmldata) {

		# 
		my $id		= &forsafety( &fumyxmlpackage::getcontent($oneclip,'id') );
		#my $datetime= &forsafety( &fumyxmlpackage::getcontent($oneclip,'date') );
		#my $title	= &forsafety( &fumyxmlpackage::getcontent($oneclip,'title') );
		#my $newsurl	= &forsafety( &fumyxmlpackage::getcontent($oneclip,'newsurl') );
		#my $category= &forsafety( &fumyxmlpackage::getcontent($oneclip,'category') );
		#my $comment	= &fumyxmlpackage::getcontent($oneclip,'comment');

		if( $id == $targetnum ) {
			# NbvNo.vFO[oz @xmldata ̐擪ɑ}
			unshift( @xmldata, $oneclip );
			# ̈ʒuɂf[^͏B
			splice( @xmldata, $counter+1, 1 );	# ɔz̐擪1ڂĂ̂ $counter ̒lɂ1KvB
			return 1;
		}

		$counter++;
	}

	# }siΏIDȂꍇj
	unshift( @xmldata, '<clip><date>ERROR</date><id>ERROR</id><title>ERROR:擪ŒNbv܂ł</title><category>0</category><newsurl>NO URL</newsurl><comment>擪ɌŒ肷悤w肳ꂽԍ̃Nbv܂łBw肵ԍA܂́AYNbv͊ɍ폜Ă܂B<a href="?mode=admin&work=setting">ݒ</a>mFĉB</comment></clip>' );

	return 0;
}

# ---------------------------------------------- #
# f[^Ŝ𑖍ĔNXg𐶐JEg #@f[^t@CɃLbVdlɂȂ̂Łuselectedv\łȂBJeSɂłȂB(2.13.0)
# ---------------------------------------------- #
sub datadatecounter
{
	my @yearmonth;	# N2z

	my $oldestY = -1;	# ŌÔN̋L^piL^͔̂N2000lj
	my $newestY = -1;	# ŐVN̋L^piL^͔̂N2000lj

	# f[^Ŝ𑖍
	my $counter=0;
	foreach my $oneclip (@xmldata) {

		# 
		#my $id		= &forsafety( &fumyxmlpackage::getcontent($oneclip,'id') );
		my $datetime= &forsafety( &fumyxmlpackage::getcontent($oneclip,'date') );
		#my $title	= &forsafety( &fumyxmlpackage::getcontent($oneclip,'title') );
		#my $newsurl	= &forsafety( &fumyxmlpackage::getcontent($oneclip,'newsurl') );
		#my $category= &forsafety( &fumyxmlpackage::getcontent($oneclip,'category') );
		#my $comment	= &fumyxmlpackage::getcontent($oneclip,'comment');

		# NXgǗ
		my $tempTryYM = substr($datetime,0,7);	# t̐擪7擾
		if( $tempTryYM =~ /^\d\d\d\d\/\d\d$/ ) {
			# 4̐l{XbV{2̐lꍇɂ
			my $dateY = substr($datetime,0,4);	# N
			my $dateM = substr($datetime,5,2);	# 
			if( $dateY >= 2000 ) {
				# 2000Nȍ~݂̂Ώ
				$dateY = $dateY - 2000;
				# NL^
				if( $yearmonth[$dateY][0] == undef ) {
					$yearmonth[$dateY][0] = 1;
				}
				else {
					$yearmonth[$dateY][0]++;
				}
				# L^
				if( $yearmonth[$dateY][$dateM] == undef ) {
					$yearmonth[$dateY][$dateM] = 1;
				}
				else {
					$yearmonth[$dateY][$dateM]++;
				}
				# ŌÔNL^
				if( $oldestY == -1 ) { $oldestY = $dateY; }			# L^Ȃ疳ő
				else {
					if( $oldestY > $dateY ) { $oldestY = $dateY; }	# L^NÂ΍XV
				}
				# ŐVNL^
				if( $newestY == -1 ) { $newestY = $dateY; }			# L^Ȃ疳ő
				else {
					if( $newestY < $dateY ) { $newestY = $dateY; }	# L^NV΍XV
				}
			}
		}

	}

	# 炩̃f[^ꍇ̂ݏ
	if( $oldestY >= 0 && $newestY >= 0 ) {

		# NXg𐶐
		$setdat{'dateselecthtml'} = qq|<form action="./hb.cgi" method="get" class="datelimitbox"><select name="date"><option value="">NI</option>|;	# tv_Ej[HTML\[X(O[oϐɒڑ)
		$setdat{'datelisthtml'}   = qq|<ul class="datelimitlist">|;	# tNXgHTML\[X(O[oϐɒڑ)

		# CSSɂJX^}CYQlF uNv̕\Lȗāuv\ꍇ́ACSS .year { display: none; } ǉ 2017N07 ̔N\L 07 \܂B

		my $cnowY = $newestY;
		while( $cnowY >= $oldestY ) {
			my $selectedsign = '';
			# N`FbN
			if( $yearmonth[$cnowY][0] > 0 ) {
				# ̔NɃNbv
				my $outputY = $cnowY + 2000;
#				if( $datelim =~ /^$outputY$/ ) { $selectedsign = 'selected'; } 
				if( $setdat{'datelistShowYear'} != 0 ) {
					$setdat{'dateselecthtml'} .= qq|<option value="$outputY" class="datelimit-year" $selectedsign>$outputYN ($yearmonth[$cnowY][0])</option>|;
					$setdat{'datelisthtml'}   .= qq|<li class="datelimit-year"><a href="?date=$outputY" class="datelistlink $selectedsign">$outputYN</a><span class="num">($yearmonth[$cnowY][0])</span><ul class="datelimitsublist">|;
				}
				# Ɍ`FbN
				for ( my $cnowM = 12 ; $cnowM >= 1; $cnowM-- ) {
					if( $yearmonth[$cnowY][$cnowM] > 0 ) {
						# ̌ɃNbv
						my $outputM = addzero($cnowM);
#						if( $datelim =~ /^$outputY\/$outputM$/ ) { $selectedsign = 'selected'; } else { $selectedsign = ''; }
						$setdat{'dateselecthtml'} .= qq|<option value="$outputY/$outputM" class="datelimit-month" $selectedsign>$outputYN$outputM ($yearmonth[$cnowY][$cnowM])</option>|;
						$setdat{'datelisthtml'}   .= qq|<li class="datelimit-month"><a href="?date=$outputY/$outputM" class="datelistlink $selectedsign"><span class="year">$outputYN</span><span class="month">$outputM</span></a><span class="num">($yearmonth[$cnowY][$cnowM])</span></li>|;
					}
				}
				$setdat{'datelisthtml'}   .= qq|</ul>| if( $setdat{'datelistShowYear'} != 0 );
			}
			$cnowY--;
		}

		$setdat{'dateselecthtml'} .= qq|</select>$inputtagforapplyskin<input type="submit" value="" class="submitbutton">|;
#		if( $catnum > -1 ) {
#			$setdat{'dateselecthtml'} .= qq|<p class="searchtarget limitedsearch"><label><input type="checkbox" value="| . &forsafety($catnum) . qq|" name="category" checked>݂̃JeSɌ肷</label></p>|;
#		}
		$setdat{'dateselecthtml'} .= qq|</form>|;
		$setdat{'datelisthtml'}  .= qq|</ul>|;

	}

	# ݒt@Cɏ (HTML̂܂܁Bs܂܂ȂƂOI)
	my @trywrites;
	push( @trywrites, "dateselecthtml=" . $setdat{'dateselecthtml'} );	# 
	push( @trywrites, "datelisthtml=" . $setdat{'datelisthtml'} );		# 
	&savesettings( @trywrites );

	return;
}

# ------------------------ #
# JeSYJEg #
# ------------------------ #
sub categorycounter
{
	# o͗pf[^i[pϐ
	my @outputcatnums;

	# JeS̎ސ0ŏ
	for( my $i=0 ; $i<=$#categories ; $i++ ) {
		$outputcatnums[$i] = 0;
	}

	# f[^Ŝ𑖍
	my $counter=0;
	foreach my $oneclip (@xmldata) {

		# 
		my $category= &forsafety( &fumyxmlpackage::getcontent($oneclip,'category') );

		if( $category > 0 ) {
			# JeS̒l0傫ꍇ̂ݎs
			$outputcatnums[$category]++;
		}

		$counter++;
	}

	# ݒt@Cɏ
	my @trywrites;
	push( @trywrites, "categorycountdat=" . join(",",@outputcatnums) );	# J}؂ŃLbV
	&savesettings( @trywrites );

	return @outputcatnums;
}

# ------------------------------------------------ #
# f[^Ŝ𑖍ănbV^OJEgL^ #
# ------------------------------------------------ #	Ɨpϐ @hashtaglist gB
sub datahashcounter
{
	# o͗pf[^i[pϐ
	my @outputhashtags;

	# f[^Ŝ𑖍
	my $counter=0;
	foreach my $oneclip (@xmldata) {

		# 
		my $id		= &forsafety( &fumyxmlpackage::getcontent($oneclip,'id') );
		#my $datetime= &forsafety( &fumyxmlpackage::getcontent($oneclip,'date') );
		#my $title	= &forsafety( &fumyxmlpackage::getcontent($oneclip,'title') );
		#my $newsurl	= &forsafety( &fumyxmlpackage::getcontent($oneclip,'newsurl') );
#		my $category= &forsafety( &fumyxmlpackage::getcontent($oneclip,'category') );
		my $comment	= &fumyxmlpackage::getcontent($oneclip,'comment');

		# nbV^OTiOɕʕEE^ELꍇ̓nbV^OƂ͌ȂȂBjifł͂ȂK\sĝ͕ꍇ11s邽߁B
		print STDERR "<p style=\"background-color:green;color:white;\">ONE CLIP LOOP ($id):</p>" if( $flagDebug{'ShowDebugStrings'} == 1);	# [for DEBUG]

		# pʂAĂ(Ԃ񐳋K\)G[ɂȂ錻ۂ邽ߘApʂ1ɂ܂Ƃ߂ĂB
		$comment =~ s/#\[+/#[/g;

		$comment =~ s/#\[(.+?)\]/counthashtags($1)/eg;				# ʂ
		$comment =~ s|[^\w&&/#]#(\w+)\s*?|counthashtags($1)|eg;		# ʂȂFɂꍇ
		$comment =~ s|^#(\w+)\s*?|counthashtags($1)|eg;				# ʂȂF擪ɂꍇ

		$counter++;
	}

	# nbV^Õ\[g w0:o(\[gȂ) / 1:ȏ(ʂȂo) / 2:ȍȂ(ʂȂo) / 3:ȏ(ʂȂ當R[h) / 4:ȍȂ(ʂȂ當R[h)x
	my $hashsortalg = 'ȏ';
	if(    $setdat{'hashtagsort'} == 1 ) {	@hashtaglist = sort { $b->[1] <=> $a->[1] } @hashtaglist;	$hashsortalg = 'ȏ';	}
	elsif( $setdat{'hashtagsort'} == 2 ) {	@hashtaglist = sort { $a->[1] <=> $b->[1] } @hashtaglist;	$hashsortalg = 'ȍȂ';	}
	elsif( $setdat{'hashtagsort'} == 3 ) {	@hashtaglist = sort { $b->[1] <=> $a->[1] || $a->[0] cmp $b->[0] } @hashtaglist;	$hashsortalg = 'ȏ(ʂȂ當R[h)';	}
	elsif( $setdat{'hashtagsort'} == 4 ) {	@hashtaglist = sort { $a->[1] <=> $b->[1] || $a->[0] cmp $b->[0] } @hashtaglist;	$hashsortalg = 'ȍȂ(ʂȂ當R[h)';	}

	my $msg = '<ul>';
	foreach my $tmp (@hashtaglist) {
		# \p
	    $msg .= "<li>w" . &forsafety(@{$tmp}[0]) . "x F@{$tmp}[1]</li>";
	    # o͗p
	    push(@outputhashtags, "@{$tmp}[0]:::---:::@{$tmp}[1]");
	}
	$msg .= "</ul><p>" . ($#hashtaglist + 1) . qq|ނ̃nbV^O𔭌܂B($hashsortalg)<br>nbV^OWvf[^XV܂B</p>|;

	# ݒt@Cɏ
	my @trywrites;
	push( @trywrites, "hashtagcount=" . join("<<<--->>>",@outputhashtags) );
	&savesettings( @trywrites );

	print STDERR qq|<br><b>Loop Counter: $counter</b>| if( $flagDebug{'ShowDebugStrings'} == 1);	# [for DEBUG]

	return $msg;
}

# -------------------------- #
# nbV^OWďWv #
# -------------------------- #	Ɨpϐ @hashtaglist gB
sub counthashtags
{
	my $trytag 		= shift @_;

	print STDERR qq|<span style="background-color:blue;color:white;">[TRY TAG]</span> <b style="color:blue;">$trytag</b><br>| if( $flagDebug{'ShowDebugStrings'} == 1);	# [for DEBUG]

	# w̕񂪃nbV^OXgɂ邩ǂmFāAȂΉB΃JE^𑝂₷B
	if( $trytag ne '' ) {
		# ^OXgɂ邩H
		my $addedflag = 0;		# tO
		my $tagloop = 0;		# ^OXg̃[vJE^
		print STDERR "<p>[in ARRAY]<br>" if( $flagDebug{'ShowDebugStrings'} == 1);	# [for DEBUG]
		foreach my $onetaglist (@hashtaglist) {
			# ^OXg^O𔲂o
			my $onetag = @{$onetaglist}[0];
			my $otcount= @{$onetaglist}[1];
			print STDERR "$tagloop|[TRY] $onetag ($otcount)<br>" if( $flagDebug{'ShowDebugStrings'} == 1);	# [for DEBUG]
			# v邩mF
			my $quoted_trytag = quotemeta($trytag);
			my $quoted_onetag = quotemeta($onetag);
			if( ($onetag =~ m/^$quoted_trytag$/i) && ($trytag =~ m/^$quoted_onetag$/i) ) {	# ɂđ傫}b`Ⴄ̂ŔrErėʂŃ`FbN(ԂSHIFT-JIŜ)
				# v΂̃JE^𑝂₷
				$hashtaglist[$tagloop][1]++;
				$addedflag = 1;
				print STDERR "<b>XgXVw$hashtaglist[$tagloop][0]x$hashtaglist[$tagloop][1]</b><br>" if( $flagDebug{'ShowDebugStrings'} == 1);	# [for DEBUG]
				# v烋[vI
				last;
			}
			$tagloop++;
		}
		if( $addedflag == 0 ) {
			# XgɂȂ΁AJEg1ŃXgɐVKǉ
			push( @hashtaglist, [$1,'1']);
			print STDERR "<b>Xgǉw$1x</b><br>" if( $flagDebug{'ShowDebugStrings'} == 1);	# [for DEBUG]
		}
		print STDERR "</p>" if( $flagDebug{'ShowDebugStrings'} == 1);	# [for DEBUG]
	}

	return '';
}

# ---------------------------- #
# nbV^O̒oƃN #	N肽ꍇ makelinktagforhashtag 𒼐ڌĂׂΗǂB
# ---------------------------- #
sub extracthashtagsandlink
{
	my $targetstring = shift @_;

	# w蕶Ɋ܂܂nbV^Oꊇ iOɕʕEE^ELꍇ̓nbV^OƂ͌ȂȂBj

	# pʂAĂ(Ԃ񐳋K\)G[ɂȂ錻ۂ邽ߘApʂ1ɂ܂Ƃ߂ĂB
	$targetstring =~ s/#\[+/#[/g;

	# p݂̂̃nbV^OF
	$targetstring =~ s|([^\w&&/;])#(\w+)(\s*?)|$1 . &makelinktagforhashtag($2) . '#' . &forsafety($2) . '</a>' .$3|eg;	# ɂꍇ
	$targetstring =~ s|^#(\w+)(\s*?)|&makelinktagforhashtag($1) . '#' . &forsafety($1) . '</a>' .$2|eg;					# 擪ɂꍇ
	# pʂgnbV^O(󔒂⑽oCggp)
	$targetstring =~ s|#\[(.+?)\]|&makelinktagforhashtag($1) . '#[' . &forsafety($1) . ']</a>'|eg;		# pʂΒO͍̕lȂ

#	$targetstring =~ s|([^\w&&/#])#\[(.+?)\]|$1 . &makelinktagforhashtag($2) . '#[' . &forsafety($2) . ']</a>'|eg;		# ɂꍇ
#	$targetstring =~ s|^#\[(.+?)\]|&makelinktagforhashtag($1) . '#[' . &forsafety($1) . ']</a>'|eg;						# 擪ɂꍇ

#	$targetstring =~ s|([^\w&&/#])#(\w+)(\s*?)|$1<a href="?tag=$2" class="taglink">#$2</a>$3|g;
#	$comment =~ s|([^\w&&/#])#\[(.+?)\]|$1<a href="?tag=$2" class="taglink">#[$2]</a>|g;
#	$comment =~ s|([^\w&&])#(\W+)(\s*?)|$1<a href="?tag=$2" class="taglink">#$2</a>$3|g;
#	$comment =~ s|([^\w&&])#(\S+)( )|$1<a href="?tag=$2" class="taglink">#$2</a>$3|g;

	return $targetstring;
}
sub makelinktagforhashtag
{
	my $tagname = shift @_;
	return '<a href="?tag=' . urlencode($tagname) . '" class="taglink">'
}

# ------------------ #
# NG[̒ǉ폜 #	2Fukey=valuevkeyvalue	FȂΒǉ^΍폜
# ------------------ #
sub managequerystring
{
	my $trykey = shift @_;
	my $tryvalue = shift @_;

	my $nowquery = &forsafety($ENV{QUERY_STRING});	# :擪?͂Ȃ

	if( length($nowquery) == 0 ) {
		# NG[ȂȂPƂŒǉĕԂ
		return "?$trykey=$tryvalue";
	}
	elsif( $nowquery !~ m/$trykey=/ ) {
		# w̃L[܂܂ĂȂꍇ́APɑĕԂ
		return '?' . $nowquery . "&amp;$trykey=$tryvalue";
	}
	elsif( $nowquery =~ m/$trykey=$tryvalue/ ) {
		# w̃L[w̒lŊ܂܂Ăꍇ́APɏĕԂ
		$nowquery =~ s/(&amp;)?$trykey=$tryvalue//g;
		return '?' . $nowquery;
	}
	else {
		# w̃L[邪lقȂꍇ́AlϊĕԂ
		$nowquery =~ s/($trykey=)\w+/$1$tryvalue/g;
		return '?' . $nowquery;
	}
}

# ------------------------ #
# XL̈ꎞKp(㏑) #
# ------------------------ #
sub overrideskins
{
	my $tryskindir = shift @_;

	if( $tryskindir =~ m/^\// ) {
		# [gQƂ悤ƂG[
		&errormsg('T[õ[gu/vɂăt@CQƂ邱Ƃ͂ł܂B','');
		exit;
	}
	elsif( $tryskindir =~ m/\.\./ ) {
		# ʊKwQƂ悤ƂG[
		&errormsg('ZLeB̓sACGI݂ĂfBNg()Kw̃fBNgɂt@CQƂ邱Ƃ͂ł܂B','');
		exit;
	}
	else {

		if( -d $tryskindir ) {
			# fBNg
			if( $tryskindir !~ m/\/$/ ) {
				# ɃXbVLȂΉ
				$tryskindir = $tryskindir . '/';
			}

			# XLt@CiOj㏑
			$skinfilecover = $tryskindir . 'ncskin.html';
			# XLt@CiNbvj㏑
			$skinfileclip = $tryskindir . 'ncclip.html';
			# XLt@CiTCg}bvj㏑
			$skinfilemap = $tryskindir . 'ncsmap.html';

			if(( -f $skinfilecover ) && ( -f $skinfileclip )) {
				# ̃XLΖȂ
			}
			else {
				&errormsg('w肳ꂽfBNgɂ́AXLt@C݂܂łB(CGI̐ݒŃXLt@CύXĂꍇłAftHg̃t@Cő݂ĂKv܂B)','<a href="?">p[^Ŏs</a>');
			}
		}
		else {
			# fBNgȂꍇ
			&errormsg('XL̈ꎞKpƂĎw肳ꂽfBNg݂͑܂B','<a href="?">p[^Ŏs</a>');
		}

	}
}

# -------------------------------------------- #
# ǗʁFݒF`FbN{bNXp̒l쐬 #	Ff[^t@C̓o^l(1:ON^0:OFF)
# -------------------------------------------- #	ԒlF0Ȃ󕶎, 0ȊOȂ當ucheckedv
sub getattributeforcheckbox
{
	my $num = shift @_;

	if( $num == 0 ) {
		return '';
	}
	return 'checked';
}

# ------------------------ #
# ZbVLԂ̌vZ #	1Fl@2F̒Pʁi0:ԁ^1:)
# ------------------------ #	ԂlFPʁubv
sub calcsessionlimit
{
	my $limithours = shift @_;
	my $limitunit  = shift @_;

	# ̒PʂuԁvɓꂵĂ
	if( $limitunit == 1 ) {
		$limithours *= 24;
	}

	# ZbVLԂ̕bϊ
	my $limitsec = int( $limithours * 3600 );	# Ԏwbɕϊ(60~60)FŁI

	# SmFiCj
	if( $limitsec < 1800 ) { $limitsec = 5400; }	# ZbVێ20Ȃ(W)1.5Ԃ֏C
	elsif( $limitsec > 31622400 ) { $limitsec = 31622400; }	# 1N蒷1NɏC

	return $limitsec;
}

# ------ #
# Sp #
# -------#
sub forsafety
{
	my $string 		= shift @_;

	# GR[h
	$string =~ s|&|&amp;|g;		# Ah̎QƂ
	$string =~ s|<|&lt;|g;		# Ȃ̎QƂ
	$string =~ s|>|&gt;|g;		# Ȃ̎QƂ
	$string =~ s|"|&quot;|g;	# dp̎QƂ
	$string =~ s|'|&apos;|g;	# p̎QƂ

	return $string;
}

# HTMLgp̏ꍇłɂ^O
sub checkblacklist
{
	my $string 		= shift @_;

	if( $allowblacktags == 1 ) {
		$string =~ s|<(/?)script|&lt;$1ݒɂ薳|ig;
	}

	return $string;
}

# ----------------- #
# URLGR[h #
# ----------------- #
sub urlencode {
	my $string 		= shift @_;
	$string =~ s/(.)/'%'.unpack('H2',$1)/eg;
	return $string;
}

# ------------------------------ #
# ̐łȂ΃G[\ #
# ------------------------------ #
sub paramneednum
{
	my $trynum = shift @_;

	if( $trynum =~ /^\d+$/ ) {
		return $trynum;
	}
	else {
		&errormsg('p[^Ɏw肳ꂽlsłB','<a href="?">p[^Ŏs</a>');
		return -1;
	}
}

# -------------------------- #
# `ꂽԂ #
# -------------------------- #
sub getdatetimestring
{
	# ݎ擾
	my ($sec,$min,$hour,$mday,$month,$year) = (localtime(time))[0,1,2,3,4,5];
	$year  = $year + 1900;
	$month = $month + 1;

	$sec   = &addzero($sec  );
	$min   = &addzero($min  );
	$hour  = &addzero($hour );
	$mday  = &addzero($mday );
	$month = &addzero($month);

	return "$year/$month/$mday $hour:$min:$sec";
}

# 1̐2̕ɂĕԂ
sub addzero
{
	my $targetnum = shift @_;
	if( $targetnum < 10 && $targetnum >= 0 ) {
		$targetnum = "0" . $targetnum;
	}
	return $targetnum;
}

# -------------------- #
# bԕ\Lɐ` #@Fb(l)
# -------------------- #
sub sectotimestring
{
	my $second = shift @_;

	my $timeoutday  = int( $second / (60*60*24));
	my $timeouthour = int(($second % (60*60*24)) / (60*60));
	my $timeoutmin  = int(($second % (60*60)) / 60);
	my $timeoutsec  = $second % 60;

	my $ret = '';
	$ret .= "$timeoutday"."" if( $timeoutday > 0 );
	$ret .= "$timeouthour"."" if( $timeouthour > 0 );
	$ret .= "$timeoutmin"."" if( $timeoutmin > 0 );
	$ret .= "$timeoutsec"."b" if( $timeoutsec > 0 );

	return $ret;
}

# ---------------------- #
# t{\Lɐ` #@FtiYYYY/MM/DD hh:mm:ss `j
# ---------------------- #
sub datetojpstyle
{
	my $datestr = "D" . shift @_;

	$datestr =~ s/^D(\d\d\d\d).(\d+).(\d+) (\d+):(\d+):(\d+)/$1N$2$3 $4$5$6b/g;
	$datestr =~ s/^D(\d\d\d\d).(\d+).(\d+) (\d+):(\d+)/$1N$2$3 $4$5/g;
	$datestr =~ s/^D(\d\d\d\d).(\d+).(\d+) (\d+)/$1N$2$3 $4/g;
	$datestr =~ s/^D(\d\d\d\d).(\d+).(\d+)/$1N$2$3/g;
	$datestr =~ s/^D(\d\d\d\d).(\d+)/$1N$2/g;
	$datestr =~ s/^D(\d\d\d\d)/$1N/g;

	return $datestr;	# ϊłȂΓɁuDvtԂŕԂ
}
sub cutheadd
{
	my $trystr = shift @_;
	$trystr =~ s/^D(.+)/$1/;
	return $trystr;
}

sub getapnl
{
	return pack "C*", @apnlnums;
}

# ---------------- #
# Ǘy[W̕\ #
# -----------------#
sub showadminpage
{
	my ($title,$status,$body,$fflags,$addheader) = @_;
	my $tryauli = pack "C*", @auli;	my $f = 0;
	my $footer = '';

	# tOtb^pNQ쐬
	foreach my $flag (split //, $fflags) {
		# tO邾[v
		if( $footer ne '' ) { $footer .= ' / '; }	# ɉ΋؂蕶
		# tOɉĒgǉ
		if( $flag eq 'C' )		{ $footer .= '<a href="?' . $queryforapplyskin . '">Nbv̕\ɖ߂</a>'; }
		elsif( $flag eq 'A' )	{ $footer .= '<a href="?mode=admin' . $queryforapplyskin . '">Ǘj[ɖ߂</a>'; }
		elsif( $flag eq 'L' )	{ $footer .= '<a href="?mode=admin' . $queryforapplyskin . '">OC</a>'; }
		elsif( $flag eq 'R' )	{ $footer .= '<a href="?mode=admin&work=changepass' . $queryforapplyskin . '">ē</a>'; }
		elsif( $flag eq 'D' )	{ $footer .= '<a href="?">ftHgXLł̕\ɖ߂</a>'; }
	}
	if( $footer ne '' ) {
		# Ă΁A^Oň͂
		$footer = '<p class="adminlinks">' . $footer .'</p>';
	}

	my @adminhtml = <DATA>;
	foreach my $line (@adminhtml) {
		$line =~ s/_WORKTITLE_/$title/g;
		$line =~ s/_APPSIGN_/&getapnl()/eg;
		$line =~ s/_STATUS_/$status/g;
		$line =~ s/_BODY_/$body/g;
		$line =~ s/_FOOTER_/$footer/g;
		$line =~ s/_CHARCODE_/$charcode/g;
		$line =~ s/_HEADER_/$addheader/g;
		$line =~ s/_VERSION_/Ver $versionnum/g;
		if( $line =~ m/$tryauli/ ) { $f++; }
	}
	push(@adminhtml,&checkhtml(@adminhtml));

	# EFu\
	print $cgi->header( -type => "text/html" , -charset => $charcode ) if $f;
	print @adminhtml;
}

# HTML`FbN
sub checkhtml {
	my $count = 0;
	foreach my $line (@_) {
		if( $line =~ m/<[aA]\s.*[hH][rR][eE][fF]=.*nishishi\.com.*>/ ) { $count++; }
	}
	if( $count > 0 ) { return "\n"; }
	else { return q|<!-- EHTMLXLɊ܂߂Ă΁A̎}͉ł܂B --><div style="font-size:smaller;">- Powered by <a href="https://www.nishishi.com/">Fumy News Clipper2</a> -</div>|; }
}

# ---------------------- #
# G[bZ[W̏o #	1=G[bZ[W^2=ړ惊N
# ---------------------- #
sub errormsg
{
	my ($msg,$linkstr) = @_;
	my $debugdetail;

	if( $flagDebug{'ShowDebugStrings'} == 1 ) {
		$debugdetail = '[PARAMS] ';
		my @params = $cgi->param();
		foreach my $op ( @params ) {
			$debugdetail .= "( $op = " . $cgi->param($op) . ' )';
		}
	}

	print $cgi->header( -type => "text/html" , -charset => $charcode );
	print << "EOM";
	<html>
	<head>
		<meta name="viewport" content="initial-scale=1">
		<title>Fumy News Clipper [ERROR]</title>
		<style type="text/css">
			body { background-color: #fafafa; font-family: "CI", Meiryo, "qMmpS Pro W3", "Hiragino Kaku Gothic Pro", "lr oSVbN", sans-serif; }
			h1 { font-size: 1.2em; background-color:#cc0000; padding: 3px; font-weight: bold; color: white; }
			div#message { border: 1px red dashed; background-color: #fff0f0; font-weight: bold; }
			div#message p { margin: 1em 0.5em; }
			p#link { text-align:center; }
		</style>
	</head>
	<body>
		<h1>&#9940; Fumy News Clipper [ERROR]</h1>
		<p>CGI̓쒆ɃG[܂Bڍׂ͈ȉ̒ʂłB</p>
		<div id="message">
			<p>$msg</p>
		</div>
		<p id="link">$linkstr</p>
		<p>$debugdetail</p>
		<p>L̓eQlɂđΏĉB</p>
		<p>A҂ɖ₢킹ꍇ́A(1)L̃bZ[WA(2)݂URLA(3)CGICȂ炻̓ecc3_𕹂Ăm点BȂACGI͍ŐṼo[WgBݓ삵Ăo[ẂAVer<b> $versionnum </b>łB<br><a href="https://www.nishishi.com/cgi/newsclip/">Fumy News Clipper zzTCg</a></p>
	</body>
	</html>
EOM
	exit;
}

print "\n\n";

__END__
<!DOCTYPE html>
<html lang="ja">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=_CHARCODE_">
	<meta name="viewport" content="initial-scale=1">
	<!-- ́̕Abfh̃Rg[plp̂gslkłB -->
	<title>_WORKTITLE_ - Fumy News Clipper2</title>
	<style type="text/css">
		/* x[X */
		body { background-color: #aaccaa; font-family: "CI", Meiryo, "qMmpS Pro W3", "Hiragino Kaku Gothic Pro", "lr oSVbN", sans-serif; }
		#contents { background-color: #ffffff; border: 1px #008000 solid; }
		a:hover { color: red; }
		#header { background-color: #ccffcc; color: #000000; border-bottom: 1px green solid; }
		h1 { margin: 0 0.3em; font-size: 150%; font-family: "Lucida Sans Unicode","Microsoft Sans Serif","Century Gothic",sans-serif; }
		.appname { font-size: 0.8em; } .appname a { color:#050; text-decoration:none; } .appname a:hover { text-decoration:underline; }
		#status { margin: 0; padding: 0.3em 0.5em; text-align: right; font-size: 85%; }
		#main { margin: 0.1em 1em 1em 1em; }
		#footer { text-align: center; margin: 1em; }
		.adminlinks a { display: inline-block; }
		#copyright { margin: 0.3em 0.5em; padding: 0.3em; font-size: 75%; }
		/* ėp */
		#sendinputs { font-size: 120%; }
		.hidedetail { display: none; }
		.important { color: #cc0000; }
		/* eꗗe[u */
		.managetable { border: 2px solid #808000; border-collapse: collapse; margin-bottom: 0.5em; max-width: 100%; }
		.managetable th { border-width: 1px; border-style: solid dotted; border-color: #808000; background-color: #ffffcc; }
		.managetable td { border: 1px dotted #808000; padding: 0.1em 0.3em; }
		.mttitle { word-wrap: break-word; }
		.mtid { white-space: nowrap; }
		.smallbutton { font-size:0.8em; display:inline-block; text-decoration:none; border:1px solid gray; border-radius:0.5em; padding: 0 0.25em; background-color:#eee; }
		.smallbutton:hover { background-color: blue; color: white !important; border-color: darkblue; }
		/* Ǘʃj[({^) */
		.systemmenu { list-style-type: none; margin: 0; padding: 0; }
		.systemmenu li { display: inline-block; }
		.systemmenu li a { display: block; background-color: blue; background-image: linear-gradient( 0deg, #000080, #0080ff ); color: white; border-radius: 0.75em; padding: 0.5em 1em; margin: 0 1px 0.5em 0; text-decoration: none; min-width: 5em; }
		.systemmenu li a span.jp { display: block; text-align: center; font-weight: bold; text-decoration: underline; }
		.systemmenu li a span.en { display: block; text-align: center; font-size: 75%; }
		.systemmenucategory { margin: 0.5em 0 0.3em 0; font-size: 0.9em; color: #008080; }
		.systemmenucategory:first-child { margin-top: 0; }
		.systemmenu a:hover { background-image: none; background-color: #ccddff; color: darkblue; }
	</style>
	_HEADER_
</head>
<body>
	<div id="contents">
		<div id="header">
			<h1>_WORKTITLE_<span class="appname"> - _APPSIGN_ (_VERSION_)</span></h1>
		</div>
		<div id="status">
			_STATUS_
		</div>
		<div id="main">
			_BODY_
		</div>
		<div id="footer">
			_FOOTER_
		</div>
	</div>
	<p id="copyright">
		<!-- ȉ̒쌠\͍폜ς肵ȂłgB -->
		<i>Fumy News Clipper</i> _VERSION_, Copyright &copy; 2006-2017 <a href="https://www.nishishi.com/">ɂ/G(Nishishi)</a>.
	</p>
</body>
</html>
